/*
 * @(#)DOMObjectType.java	1.3 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package sun.plugin.dom;

/**
 * An interface that encloses all possible DOM object type.
 */
public interface DOMObjectType
{
    public static int Attr = 1;
    public static int CDATASection = 2;
    public static int CharacterData = 3;
    public static int Comment = 4;
    public static int Document = 5;
    public static int DocumentFragment = 6;
    public static int DocumentType = 7;
    public static int DOMException = 8;
    public static int DOMImplementation = 9;
    public static int Element = 10;
    public static int Entity = 11;
    public static int EntityReference = 12;
    public static int NamedNodeMap = 13;
    public static int Node = 14;
    public static int NodeList = 15; 
    public static int Notation = 16;
    public static int ProcessingInstruction = 17;
    public static int Text = 18;
    public static int HTMLAnchorElement = 19;
    public static int HTMLAppletElement = 20;
    public static int HTMLAreaElement = 21;
    public static int HTMLBaseElement = 22;
    public static int HTMLBaseFontElement = 23;
    public static int HTMLBodyElement = 24;
    public static int HTMLBRElement = 25;
    public static int HTMLButtonElement = 26; 
    public static int HTMLCollection = 27;
    public static int HTMLDirectoryElement = 28;
    public static int HTMLDivElement = 29;
    public static int HTMLDListElement = 30;
    public static int HTMLDocument = 31;
    public static int HTMLDOMImplementation = 32;
    public static int HTMLElement = 33;
    public static int HTMLFieldSetElement = 34;
    public static int HTMLFontElement = 35;
    public static int HTMLFormElement = 36;
    public static int HTMLFrameElement = 37;
    public static int HTMLFrameSetElement = 38;
    public static int HTMLHeadElement = 39;
    public static int HTMLHeadingElement = 40;
    public static int HTMLHRElement = 41;
    public static int HTMLHtmlElement = 42;
    public static int HTMLIFrameElement = 43;
    public static int HTMLImageElement = 44;
    public static int HTMLInputElement = 45;
    public static int HTMLIsIndexElement = 46;
    public static int HTMLLabelElement = 47;
    public static int HTMLLegendElement = 48;
    public static int HTMLLIElement = 49;
    public static int HTMLLinkElement = 50;
    public static int HTMLMapElement = 51;
    public static int HTMLMenuElement = 52;
    public static int HTMLMetaElement = 53;
    public static int HTMLModElement = 54;
    public static int HTMLObjectElement = 55;
    public static int HTMLOListElement = 56;
    public static int HTMLOptGroupElement = 57;
    public static int HTMLOptionElement = 58;
    public static int HTMLParagraphElement = 59;
    public static int HTMLParamElement = 60;
    public static int HTMLPreElement = 61;
    public static int HTMLQuoteElement = 62;
    public static int HTMLScriptElement = 63;
    public static int HTMLSelectElement = 64;
    public static int HTMLStyleElement = 65;
    public static int HTMLTableCaptionElement = 66;
    public static int HTMLTableCellElement = 67;
    public static int HTMLTableColElement = 68;
    public static int HTMLTableElement = 69;
    public static int HTMLTableSectionElement = 70;
    public static int HTMLTableRowElement = 71;
    public static int HTMLTextAreaElement = 72;
    public static int HTMLTitleElement = 73;
    public static int HTMLUListElement = 74;
    public static int AbstractView = 75;
    public static int DocumentView = 76;
    public static int DocumentStyle = 77;
    public static int LinkStyle = 78;
    public static int MediaList = 79;
    public static int StyleSheet = 80;
    public static int StyleSheetList = 81;
    public static int DocumentEvent = 82;
    public static int Event = 83;
    public static int EventException = 84;
    public static int EventListener = 85;
    public static int EventTarget = 86;
    public static int MouseEvent = 87;
    public static int MutationEvent = 88;
    public static int UIEvent = 89;
    public static int Counter = 90;
    public static int CSS2Azimuth = 91;
    public static int CSS2BackgroundPosition = 92;
    public static int CSS2BorderSpacing = 93;
    public static int CSS2CounterIncrement = 94;
    public static int CSS2CounterReset = 95;
    public static int CSS2Cursor = 96;
    public static int CSS2FontFaceSrc = 97;
    public static int CSS2FontFaceWidths = 98;
    public static int CSS2PageSize = 99;
    public static int CSS2PlayDuring = 100;
    public static int CSS2Properties = 101;
    public static int CSS2TextShadow = 102;
    public static int CSSCharsetRule = 103;
    public static int CSSFontFaceRule = 104;
    public static int CSSImportRule = 105;
    public static int CSSMediaRule = 106;
    public static int CSSPageRule = 107;
    public static int CSSPrimitiveValue = 108;
    public static int CSSRule = 109;
    public static int CSSRuleList = 110;
    public static int CSSStyleDeclaration = 111;
    public static int CSSStyleRule = 112;
    public static int CSSStyleSheet = 113;
    public static int CSSUnknownRule = 114;
    public static int CSSValue = 115;
    public static int CSSValueList = 116;
    public static int DocumentCSS = 117;
    public static int DOMImplementationCSS = 118;
    public static int ElementCSSInlineStyle = 119;
    public static int Rect = 120;
    public static int RGBColor = 121;
    public static int ViewCSS = 122;
}

