/*
 * @(#)eventFilter.h	1.4 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef _EVENT_FILTER_H
#define _EVENT_FILTER_H

#include <jni.h>
#include <jvmdi.h>
#include "eventHandler.h"

/***** filter set-up *****/

jint eventFilter_setConditionalFilter(HandlerNode *node,
                                      jint index, jint exprID);
jint eventFilter_setCountFilter(HandlerNode *node,
                                jint index, jint count);
jint eventFilter_setThreadOnlyFilter(HandlerNode *node,
                                     jint index, jthread thread);
jint eventFilter_setLocationOnlyFilter(HandlerNode *node,
                                       jint index, 
                                       jclass clazz, 
                                       jmethodID method, 
                                       jlocation location);
jint eventFilter_setFieldOnlyFilter(HandlerNode *node,
                                    jint index, 
                                    jclass clazz, 
                                    jfieldID field);
jint eventFilter_setClassOnlyFilter(HandlerNode *node,
                                    jint index, 
                                    jclass clazz);
jint eventFilter_setExceptionOnlyFilter(HandlerNode *node,
                                        jint index, 
                                        jclass exceptionClass, 
                                        jboolean caught, 
                                        jboolean uncaught);
jint eventFilter_setInstanceOnlyFilter(HandlerNode *node,
                                       jint index, 
                                       jobject object);
jint eventFilter_setClassMatchFilter(HandlerNode *node,
                                     jint index, 
                                     char *classPattern);
jint eventFilter_setClassExcludeFilter(HandlerNode *node,
                                       jint index, 
                                       char *classPattern);
jint eventFilter_setStepFilter(HandlerNode *node,
                               jint index, 
                               jthread thread, 
                               jint size, jint depth);

/***** misc *****/

jboolean eventFilter_predictFiltering(HandlerNode *node, jframeID frame);
jboolean isBreakpointSet(jclass clazz, jmethodID method, jlocation location);

#endif /* _EVENT_FILTER_H */
