/*
 * @(#)eventFilterRestricted.h	1.4 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
/**
 * eventFilter functionality restricted to use only by it's
 * enclosing module - eventHandler.
 */

HandlerNode *eventFilterRestricted_alloc(jint filterCount);

jint eventFilterRestricted_install(HandlerNode *node);

jint eventFilterRestricted_deinstall(HandlerNode *node);

jboolean eventFilterRestricted_passesFilter(JNIEnv *env, 
                                            JVMDI_Event *event, 
                                            HandlerNode *node, 
                                            jboolean *shouldDelete);
jboolean eventFilterRestricted_passesUnloadFilter(JNIEnv *env, 
                                                  char *classname, 
                                                  HandlerNode *node, 
                                                  jboolean *shouldDelete);
jboolean eventFilterRestricted_isBreakpointInClass(JNIEnv *env, 
                                                   jclass clazz, 
                                                   HandlerNode *node);
