/*
 * @(#)threadControl.h	1.41 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#include <jni.h>
#include "stepControl.h"
#include "invoker.h"
#include "bag.h"

void threadControl_initialize(void);
void threadControl_reset(void);
void threadControl_detachInvokes(void);

void threadControl_onHook(void);
void threadControl_onConnect(void);
void threadControl_onDisconnect(void);
struct bag *threadControl_onEventHandlerEntry(jbyte sessionID, 
                                              jint kind, jthread thread);
void threadControl_onEventHandlerExit(jint kind, jthread thread, struct bag *);


jint threadControl_suspendThread(jthread thread, jboolean deferred);
jint threadControl_resumeThread(jthread thread, jboolean do_unblock);
jint threadControl_suspendCount(jthread thread, jint *count);

jint threadControl_suspendAll(void);
jint threadControl_resumeAll(void);

StepRequest *threadControl_getStepRequest(jthread);
InvokeRequest *threadControl_getInvokeRequest(jthread);

jboolean threadControl_isDebugThread(jthread thread);
jint threadControl_addDebugThread(jthread thread);
jint threadControl_removeDebugThread(jthread thread);

jint threadControl_applicationThreadStatus(jthread thread, jint *threadStatus, jint *suspendStatus);
jint threadControl_interrupt(jthread thread);
jint threadControl_stop(jthread thread, jobject throwable);

jint threadControl_setEventMode(jint mode, jint event, jthread thread);
jint threadControl_getInstructionStepMode(jthread thread);

jint threadControl_getFrameLocation(jthread thread, jframeID frame,
                      jclass *clazz, jmethodID *method, jlocation *location);
jthread threadControl_currentThread(void);
void threadControl_setPendingInterrupt(jthread thread);
void threadControl_clearCLEInfo(JNIEnv *env, jthread thread);
jboolean threadControl_cmpCLEInfo(JNIEnv *env, jthread thread, jclass clazz,
                                  jmethodID method, jlocation location);
void threadControl_saveCLEInfo(JNIEnv *env, jthread thread, jint kind,
                               jclass clazz, jmethodID method,
                               jlocation location);
jboolean threadControl_getPopFrameEvent(jthread thread);
void threadControl_setPopFrameEvent(jthread thread, jint value);
jboolean threadControl_getPopFrameProceed(jthread thread);
void threadControl_setPopFrameProceed(jthread thread, jint value);
