/*
 * @(#)RMIConstants.java	1.12 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * Licensed Materials - Property of IBM
 * RMI-IIOP v1.0
 * Copyright IBM Corp. 1998 1999  All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package sun.rmi.rmic;

import sun.tools.java.Identifier;

public interface RMIConstants extends sun.rmi.rmic.Constants {

    /*
     * identifiers for RMI classes referenced by rmic
     */
    public static final Identifier idRemoteObject =
	Identifier.lookup("java.rmi.server.RemoteObject");
    public static final Identifier idRemoteStub =
	Identifier.lookup("java.rmi.server.RemoteStub");
    public static final Identifier idRemoteRef =
	Identifier.lookup("java.rmi.server.RemoteRef");
    public static final Identifier idOperation =
	Identifier.lookup("java.rmi.server.Operation");
    public static final Identifier idSkeleton =
	Identifier.lookup("java.rmi.server.Skeleton");
    public static final Identifier idSkeletonMismatchException =
	Identifier.lookup("java.rmi.server.SkeletonMismatchException");
    public static final Identifier idRemoteCall =
	Identifier.lookup("java.rmi.server.RemoteCall");
    public static final Identifier idMarshalException =
	Identifier.lookup("java.rmi.MarshalException");
    public static final Identifier idUnmarshalException =
	Identifier.lookup("java.rmi.UnmarshalException");
    public static final Identifier idUnexpectedException =
	Identifier.lookup("java.rmi.UnexpectedException");

    /*
     * stub protocol versions
     */
    public static final int STUB_VERSION_1_1  = 1;
    public static final int STUB_VERSION_FAT  = 2;
    public static final int STUB_VERSION_1_2  = 3;

    /** serialVersionUID for all stubs that can use 1.2 protocol */
    public static final long STUB_SERIAL_VERSION_UID = 2;

    /** version number used to seed interface hash computation */
    public static final int INTERFACE_HASH_STUB_VERSION = 1;
}
