/*
 * @(#)DateFormatZoneData_es.java	1.31 03/05/09
 */

/*
 * Portions Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * (C) Copyright Taligent, Inc. 1996, 1997 - All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998 - All Rights Reserved
 *
 * The original version of this source code and documentation
 * is copyrighted and owned by Taligent, Inc., a wholly-owned
 * subsidiary of IBM. These materials are provided under terms
 * of a License Agreement between Taligent and Sun. This technology
 * is protected by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.text.resources;

/**
 * Supplement package private date-time formatting zone data for DateFormat.
 * DateFormatData used in DateFormat will be initialized by loading the data
 * from LocaleElements and DateFormatZoneData resources. The zone data are
 * represented with the following form:
 * {ID, new String[] {ID, long zone string, short zone string, long daylight
 * string, short daylight string, representative city of zone}}, where ID is
 * NOT localized, but is used to look up the localized timezone data
 * internally. Localizers can localize any zone strings except
 * for the ID of the timezone.
 * Also, localizer should not touch "localPatternChars" entry.
 *
 * @see          Format
 * @see          DateFormatData
 * @see          LocaleElements
 * @see          SimpleDateFormat
 * @see          TimeZone
 * @version      1.23 08/05/01
 * @author       Chen-Lieh Huang
 */
//  Spanish DateFormatZoneData
//
public final class DateFormatZoneData_es extends DateFormatZoneData
{
    /**
     * Overrides DateFormatZoneData
     */
    public Object[][] getContents() {
	String ACT[] = new String[] {"Hora de Acre", "ACT",
				     "Hora de verano de Acre", "ACST"};
	String AGT[] = new String[] {"Hora de Argentina", "ART",
				     "Hora de verano de Argentina", "ARST"};
	String AKST[] = new String[] {"Hora est\u00e1ndar de Alaska", "AKST",
				      "Hora de verano de Alaska", "AKDT"};
	String AMT[] = new String[] {"Hora est\u00e1ndar de Amazonia", "AMT",
				     "Hora de verano de Amazonia", "AMST"};
	String ARAST[] = new String[] {"Hora est\u00e1ndar de Arabia", "AST",
				       "Hora de verano de Arabia", "ADT"};
	String ARMT[] = new String[] {"Hora de Armenia", "AMT",
				      "Hora de verano de Armenia", "AMST"};
	String AST[] = new String[] {"Hora est\u00e1ndar Atl\u00e1ntico", "AST",
				     "Hora de verano Atl\u00e1ntico", "ADT"};
	String BDT[] = new String[] {"Hora de Bangladesh", "BDT",
				     "Hora de verano de Bangladesh", "BDST"};
	String BRT[] = new String[] {"Hora de Brasil", "BRT",
				     "Hora de verano de Brasil", "BRST"};
	String BTT[] = new String[] {"Hora de But\u00e1n", "BTT",
				     "Hora de verano de But\u00e1n", "BTST"};
	String CAT[] = new String[] {"Hora de \u00c1frica Central", "CAT",
				     "Hora de verano de \u00c1frica Central", "CAST"};
	String CET[] = new String[] {"Hora de Europa Central", "CET",
				     "Hora de verano de Europa Central", "CEST"};
	String CIT[] = new String[] {"Hora de Indonesia Central", "CIT",
				     "Hora de verano de Indonesia Central", "CIST"};
	String CLT[] = new String[] {"Hora de Chile", "CLT",
				     "Hora de verano de Chile", "CLST"};
	String CST[] = new String[] {"Hora est\u00e1ndar Central", "CST",
				     "Hora de verano Central", "CDT"};
	String CTT[] = new String[] {"Hora est\u00e1ndar de China", "CST",
				     "Hora de verano de China", "CDT"};
	String EAT[] = new String[] {"Hora de \u00c1frica Oriental", "EAT",
				     "Hora de verano de \u00c1frica Oriental", "EAST"};
	String EET[] = new String[] {"Hora de Europa Oriental", "EET",
				     "Hora de verano de Europa Oriental", "EEST"};
	String EGT[] = new String[] {"Hora de Groenlandia Oriental", "EGT",
				     "Hora de verano de Groenlandia Oriental", "EGST"};
	String EST[] = new String[] {"Hora est\u00e1ndar Oriental", "EST",
				     "Hora de verano Oriental", "EDT"};
	String EST_NSW[] = new String[] {"Hora est\u00e1ndar Oriental (Nueva Gales del Sur)", "EST",
					 "Hora de verano Oriental (Nueva Gales del Sur)", "EST"};
	String GMT[] = new String[] {"Hora media de Greenwich", "GMT",
				   "Hora media de Greenwich", "GMT"};
	String GST[] = new String[] {"Hora est\u00e1ndar del Golfo", "GST",
				     "Hora de verano del Golfo", "GDT"};
	String HAST[] = new String[] {"Hora est\u00e1ndar de Hawaii-Aleutianas", "HAST",
				      "Hora de verano de Hawaii-Aleutianas", "HADT"};
	String HST[] = new String[] {"Hora est\u00e1ndar de Hawaii", "HST",
				     "Hora de verano de Hawaii", "HDT"};
	String ICT[] = new String[] {"Hora de Indochina", "ICT",
				     "Hora de verano de Indochina", "ICST"};
	String IRT[] = new String[] {"Hora est\u00e1ndar de Ir\u00e1n", "IRST",
				     "Hora de verano de Ir\u00e1n", "IRDT"};
	String IST[] = new String[] {"Hora est\u00e1ndar de India", "IST",
				     "Hora de verano de India", "IDT"};
	String JST[] = new String[] {"Hora est\u00e1ndar de Jap\u00f3n", "JST",
				     "Hora de verano de Jap\u00f3n", "JDT"};
	String KST[] = new String[] {"Hora est\u00e1ndar de Corea", "KST",
				     "Hora de verano de Corea", "KDT"};
	String MST[] = new String[] {"Hora est\u00e1ndar de las Rocosas", "MST",
				     "Hora de verano de las Rocosas", "MDT"};
	String NST[] = new String[] {"Hora est\u00e1ndar de Terranova", "NST",
				     "Hora de verano de Terranova", "NDT"};
	String NZST[] = new String[] {"Hora est\u00e1ndar de Nueva Zelanda", "NZST",
				      "Hora de verano de Nueva Zelanda", "NZDT"};
	String PKT[] = new String[] {"Hora de Pakist\u00e1n", "PKT",
				     "Hora de verano de Pakist\u00e1n", "PKST"};
	String PST[] = new String[] {"Hora est\u00e1ndar del Pac\u00edfico", "PST",
				     "Hora de verano del Pac\u00edfico", "PDT"};
	String SAST[] = new String[] {"Hora est\u00e1ndar de Sud\u00e1frica", "SAST",
				      "Hora de verano de Sud\u00e1frica", "SAST"};
	String SBT[] = new String[] {"Hora de las Islas Solomon", "SBT",
				     "Hora de verano de las Islas Solomon", "SBST"};
	String TMT[] = new String[] {"Hora de Turkmenist\u00e1n", "TMT",
				     "Hora de verano de Turkmenist\u00e1n", "TMST"};
	String ULAT[]= new String[] {"Hora de Ulan Bator", "ULAT",
				     "Hora de verano de Ulan Bator", "ULAST"};
	String WAT[] = new String[] {"Hora de \u00c1frica Occidental", "WAT",
				     "Hora de verano de \u00c1frica Occidental", "WAST"};
	String WET[] = new String[] {"Hora de Europa Occidental", "WET",
				     "Hora de verano de Europa Occidental", "WEST"};
	String WST_AUS[] = new String[] {"Hora est\u00e1ndar Occidental (Australia)", "WST",
					 "Hora de verano Occidental (Australia)", "WST"};
	String WST_SAMOA[] = new String[] {"Hora de Samoa Occidental", "WST",
					   "Hora de verano de Samoa Occidental", "WSST"};
    String ChST[] = new String[] {"Chamorro Standard Time", "ChST",
                      "Hora de verano de Chamorro", "ChDT"};

	return new Object[][] {
	    {"PST", PST},
	    {"America/Los_Angeles", PST},
	    {"MST", MST},
	    {"America/Denver", MST},
	    {"PNT", MST},
	    {"America/Phoenix", MST},
	    {"CST", CST},
	    {"America/Chicago", CST},
	    {"EST", EST},
	    {"America/New_York", EST},
	    {"IET", EST},
	    {"America/Indianapolis", EST},
	    {"HST", HST},
	    {"Pacific/Honolulu", HST},
	    {"AST", AKST},
	    {"America/Anchorage", AKST},
	    {"America/Halifax", AST},
	    {"CNT", NST},
	    {"America/St_Johns", NST},
	    {"ECT", CET},
	    {"Europe/Paris", CET},
	    {"GMT", GMT},
	    {"Africa/Casablanca", WET},
	    {"Asia/Jerusalem", new String[] {"Hora est\u00e1ndar de Israel", "IST",
					     "Hora de verano de Israel", "IDT"}},
	    {"JST", JST},
	    {"Asia/Tokyo", JST},
	    {"Europe/Bucharest", EET},
	    {"CTT", CTT},
	    {"Asia/Shanghai", CTT},
	    /* Don't change the order of the above zones
	     * to keep compatibility with the previous version.
	     */

	    {"ACT", new String[] {"Hora est\u00e1ndar Central (Territorio del Norte)", "CST",
				  "Hora de verano central (Territorio del Norte)", "CDT"}},
	    {"AET", EST_NSW},
	    {"AGT", AGT},
	    {"ART", EET},
	    {"Africa/Abidjan", GMT},
	    {"Africa/Accra", GMT},
	    {"Africa/Addis_Ababa", EAT},
	    {"Africa/Algiers", CET},
	    {"Africa/Asmera", EAT},
	    {"Africa/Bangui", WAT},
	    {"Africa/Banjul", GMT},
	    {"Africa/Bissau", GMT},
	    {"Africa/Blantyre", CAT},
	    {"Africa/Bujumbura", CAT},
	    {"Africa/Cairo", EET},
	    {"Africa/Conakry", GMT},
	    {"Africa/Dakar", GMT},
	    {"Africa/Dar_es_Salaam", EAT},
	    {"Africa/Djibouti", EAT},
	    {"Africa/Douala", WAT},
	    {"Africa/Freetown", GMT},
	    {"Africa/Gaborone", CAT},
	    {"Africa/Harare", CAT},
	    {"Africa/Johannesburg", SAST},
	    {"Africa/Kampala", EAT},
	    {"Africa/Khartoum", EAT},
	    {"Africa/Kigali", CAT},
	    {"Africa/Kinshasa", WAT},
	    {"Africa/Lagos", WAT},
	    {"Africa/Libreville", WAT},
	    {"Africa/Lome", GMT},
	    {"Africa/Luanda", WAT},
	    {"Africa/Lubumbashi", CAT},
	    {"Africa/Lusaka", CAT},
	    {"Africa/Malabo", WAT},
	    {"Africa/Maputo", CAT},
	    {"Africa/Maseru", SAST},
	    {"Africa/Mbabane", SAST},
	    {"Africa/Mogadishu", EAT},
	    {"Africa/Monrovia", GMT},
	    {"Africa/Nairobi", EAT},
	    {"Africa/Ndjamena", WAT},
	    {"Africa/Niamey", WAT},
	    {"Africa/Nouakchott", GMT},
	    {"Africa/Ouagadougou", GMT},
	    {"Africa/Porto-Novo", WAT},
	    {"Africa/Sao_Tome", GMT},
	    {"Africa/Timbuktu", GMT},
	    {"Africa/Tripoli", EET},
	    {"Africa/Tunis", CET},
	    {"Africa/Windhoek", WAT},
	    {"America/Adak", HAST},
	    {"America/Anguilla", AST},
	    {"America/Antigua", AST},
	    {"America/Aruba", AST},
	    {"America/Asuncion", new String[] {"Hora de Paraguay", "PYT",
					       "Hora de verano de Paraguay", "PYST"}},
	    {"America/Barbados", AST},
	    {"America/Belize", CST},
	    {"America/Bogota", new String[] {"Hora de Colombia", "COT",
					     "Hora de verano de Colombia", "COST"}},
	    {"America/Buenos_Aires", AGT},
	    {"America/Caracas", new String[] {"Hora de Venezuela", "VET",
					      "Hora de verano de Venezuela", "VEST"}},
	    {"America/Cayenne", new String[] {"Hora de la Guayana Francesa", "GFT",
					      "Hora de verano de la Guayana Francesa", "GFST"}},
	    {"America/Cayman", EST},
	    {"America/Costa_Rica", CST},
	    {"America/Cuiaba", AMT},
	    {"America/Curacao", AST},
	    {"America/Dawson_Creek", MST},
	    {"America/Dominica", AST},
	    {"America/Edmonton", MST},
	    {"America/El_Salvador", CST},
	    {"America/Fortaleza", BRT},
	    {"America/Godthab", new String[] {"Hora de Groenlandia Occidental", "WGT",
					      "Hora de verano de Groenlandia Occidental", "WGST"}},
	    {"America/Grand_Turk", EST},
	    {"America/Grenada", AST},
	    {"America/Guadeloupe", AST},
	    {"America/Guatemala", CST},
	    {"America/Guayaquil", new String[] {"Hora de Ecuador", "ECT",
						"Hora de verano de Ecuador", "ECST"}},
	    {"America/Guyana", new String[] {"Hora de Guyana", "GYT",
					     "Hora de verano de Guyana", "GYST"}},
	    {"America/Havana", CST},
	    {"America/Jamaica", EST},
	    {"America/La_Paz", new String[] {"Hora de Bolivia", "BOT",
					     "Hora de verano de Bolivia", "BOST"}},
	    {"America/Lima", new String[] {"Hora de Per\u00fa", "PET",
					   "Hora de verano de Per\u00fa", "PEST"}},
	    {"America/Managua", CST},
	    {"America/Manaus", AMT},
	    {"America/Martinique", AST},
	    {"America/Mazatlan", MST},
	    {"America/Mexico_City", CST},
	    {"America/Miquelon", new String[] {"Hora est\u00e1ndar de Pierre & Miquelon", "PMST",
					       "Hora de verano de Pierre & Miquelon", "PMDT"}},
	    {"America/Montevideo", new String[] {"Hora de Uruguay", "UYT",
						 "Hora de verano de Uruguay", "UYST"}},
	    {"America/Montreal", EST},
	    {"America/Montserrat", AST},
	    {"America/Nassau", EST},
	    {"America/Noronha", new String[] {"Hora de Fernando de Noronha", "FNT",
					      "Hora de verano de Fernando de Noronha", "FNST"}},
	    {"America/Panama", EST},
	    {"America/Paramaribo", new String[] {"Hora de Surinam", "SRT",
						 "Hora de verano de Surinam", "SRST"}},
	    {"America/Port-au-Prince", EST},
	    {"America/Port_of_Spain", AST},
	    {"America/Porto_Acre", ACT},
	    {"America/Puerto_Rico", AST},
	    {"America/Regina", CST},
	    {"America/Rio_Branco", ACT},
	    {"America/Santiago", CLT},
	    {"America/Santo_Domingo", AST},
	    {"America/Sao_Paulo", BRT},
	    {"America/Scoresbysund", EGT},
	    {"America/St_Kitts", AST},
	    {"America/St_Lucia", AST},
	    {"America/St_Thomas", AST},
	    {"America/St_Vincent", AST},
	    {"America/Tegucigalpa", CST},
	    {"America/Thule", AST},
	    {"America/Tijuana", PST},
	    {"America/Tortola", AST},
	    {"America/Vancouver", PST},
	    {"America/Winnipeg", CST},
	    {"Antarctica/Casey", WST_AUS},
	    {"Antarctica/DumontDUrville", new String[] {"Hora de Dumont-d'Urville", "DDUT",
							"Hora de verano de Dumont-d'Urville", "DDUST"}},
	    {"Antarctica/Mawson", new String[] {"Hora de Mawson", "MAWT",
						"Hora de verano de Mawson", "MAWST"}},
	    {"Antarctica/McMurdo", NZST},
	    {"Antarctica/Palmer", CLT},
	    {"Antarctica/Rothera", new String[] {"Hora de Rothera", "ROTT",
						 "Hora de verano de Rothera", "ROTST"}},
	    {"Asia/Aden", ARAST},
	    {"Asia/Almaty", new String[] {"Hora de Alma-Ata", "ALMT",
					  "Hora de verano de Alma-Ata", "ALMST"}},
	    {"Asia/Amman", EET},
	    {"Asia/Anadyr", new String[] {"Hora de Anadyr", "ANAT",
					  "Hora de verano de Anadyr", "ANAST"}},
	    {"Asia/Aqtau", new String[] {"Hora de Aqtau", "AQTT",
					 "Hora de verano de Aqtau", "AQTST"}},
	    {"Asia/Aqtobe", new String[] {"Hora de Aqtobe", "AQTT",
					  "Hora de verano de Aqtobe", "AQTST"}},
	    {"Asia/Ashgabat", TMT},
	    {"Asia/Ashkhabad", TMT},
	    {"Asia/Baghdad", ARAST},
	    {"Asia/Bahrain", ARAST},
	    {"Asia/Baku", new String[] {"Hora de Azerbaiy\u00e1n", "AZT",
					"Hora de verano de Azerbaiy\u00e1n", "AZST"}},
	    {"Asia/Bangkok", ICT},
	    {"Asia/Beirut", EET},
	    {"Asia/Bishkek", new String[] {"Hora de Kirguizist\u00e1n", "KGT",
					   "Hora de verano de Kirguizist\u00e1n", "KGST"}},
	    {"Asia/Brunei", new String[] {"Hora de Brunei", "BNT",
					  "Hora de verano de Brunei", "BNST"}},
	    {"Asia/Calcutta", IST},
	    {"Asia/Colombo", new String[] {"Hora de Sri Lanka", "LKT",
					   "Hora de verano de Sri Lanka", "LKST"}},
	    {"Asia/Dacca", BDT},
	    {"Asia/Dhaka", BDT},
	    {"Asia/Damascus", EET},
	    {"Asia/Dubai", GST},
	    {"Asia/Dushanbe", new String[] {"Hora de Tajikist\u00e1n", "TJT",
					    "Hora de verano de Tajikist\u00e1n", "TJST"}},
	    {"Asia/Hong_Kong", new String[] {"Hora de Hong Kong", "HKT",
					     "Hora de verano de Hong Kong", "HKST"}},
	    {"Asia/Irkutsk", new String[] {"Hora de Irkutsk", "IRKT",
					   "Hora de verano de Irkutsk", "IRKST"}},
        {"Asia/Jakarta", new String[] {"West Indonesia Time", "WIT",
                       "West Indonesia Summer Time", "WIST"}},
        {"Asia/Jayapura", new String[] {"East Indonesia Time", "EIT",
                        "East Indonesia Summer Time", "EIST"}},
	    {"Asia/Kabul", new String[] {"Hora de Afganist\u00e1n", "AFT",
					 "Hora de verano de Afganist\u00e1n", "AFST"}},
	    {"Asia/Kamchatka", new String[] {"Hora de Petropavlovsk-Kamchatski", "PETT",
					     "Hora de verano de Petropavlovsk-Kamchatski", "PETST"}},
	    {"Asia/Karachi", PKT},
	    {"Asia/Katmandu", new String[] {"Hora de Nepal", "NPT",
					    "Hora de verano de Nepal", "NPST"}},
	    {"Asia/Krasnoyarsk", new String[] {"Hora de Krasnoyarsk", "KRAT",
					       "Hora de verano de Krasnoyarsk", "KRAST"}},
	    {"Asia/Kuala_Lumpur", new String[] {"Hora de Malasia", "MYT",
						"Hora de verano de Malasia", "MYST"}},
	    {"Asia/Kuwait", ARAST},
	    {"Asia/Macao", CTT},
	    {"Asia/Macau", CTT},
	    {"Asia/Magadan", new String[] {"Hora de Magad\u00e1n", "MAGT",
					   "Hora de verano de Magad\u00e1n", "MAGST"}},
	    {"Asia/Makassar", CIT},
	    {"Asia/Manila", new String[] {"Hora de Filipinas", "PHT",
					  "Hora de verano de Filipinas", "PHST"}},
	    {"Asia/Muscat", GST},
	    {"Asia/Nicosia", EET},
	    {"Asia/Novosibirsk", new String[] {"Hora de Novosibirsk", "NOVT",
					       "Hora de verano de Novosibirsk", "NOVST"}},
	    {"Asia/Oral", new String[] {"Hora de Uralsk", "ORAT",
					"Hora de verano de Uralsk", "ORAST"}},
	    {"Asia/Phnom_Penh", ICT},
	    {"Asia/Pyongyang", KST},
	    {"Asia/Qatar", ARAST},
	    {"Asia/Qyzylorda", new String[] {"Hora de Qyzylorda", "QYZT",
					     "Hora de verano de Qyzylorda", "QYZST"}},
	    {"Asia/Rangoon", new String[] {"Hora de Myanmar", "MMT",
					   "Hora de verano de Myanmar", "MMST"}},
	    {"Asia/Riyadh", ARAST},
	    {"Asia/Saigon", ICT},
	    {"Asia/Seoul", KST},
	    {"Asia/Singapore", new String[] {"Hora de Singapur", "SGT",
					     "Hora de verano de Singapur", "SGST"}},
	    {"Asia/Taipei", CTT},
	    {"Asia/Tashkent", new String[] {"Hora de Uzbekist\u00e1n", "UZT",
		                            "Hora de verano de Uzbekist\u00e1n", "UZST"}},
	    {"Asia/Tbilisi", new String[] {"Hora de Georgia", "GET",
					   "Hora de verano de Georgia", "GEST"}},
	    {"Asia/Tehran", IRT},
	    {"Asia/Thimbu", BTT},
	    {"Asia/Thimphu", BTT},
	    {"Asia/Ujung_Pandang", CIT},
	    {"Asia/Ulaanbaatar", ULAT},
	    {"Asia/Ulan_Bator", ULAT},
	    {"Asia/Vientiane", ICT},
	    {"Asia/Vladivostok", new String[] {"Hora de Vladivostok", "VLAT",
					       "Hora de verano de Vladivostok", "VLAST"}},
	    {"Asia/Yakutsk", new String[] {"Hora de Yakutsk", "YAKT",
					   "Hora de verano de Yakutsk", "YAKST"}},
	    {"Asia/Yekaterinburg", new String[] {"Hora de Ekaterinburgo", "YEKT",
						 "Hora de verano de Ekaterinburgo", "YEKST"}},
	    {"Asia/Yerevan", ARMT},
	    {"Atlantic/Azores", new String[] {"Hora de Azores", "AZOT",
					      "Hora de verano de Azores", "AZOST"}},
	    {"Atlantic/Bermuda", AST},
	    {"Atlantic/Canary", WET},
	    {"Atlantic/Cape_Verde", new String[] {"Hora de Cabo Verde", "CVT",
						  "Hora de verano de Cabo Verde", "CVST"}},
	    {"Atlantic/Faeroe", WET},
	    {"Atlantic/Jan_Mayen", EGT},
	    {"Atlantic/Reykjavik", GMT},
	    {"Atlantic/South_Georgia", new String[] {"Hora est\u00e1ndar de Georgia del Sur", "GST",
						     "Hora de verano de Georgia del Sur", "GDT"}},
	    {"Atlantic/St_Helena", GMT},
	    {"Atlantic/Stanley", new String[] {"Hora de las islas Malvinas", "FKT",
					       "Hora de verano de las islas Malvinas", "FKST"}},
	    {"Australia/Adelaide", new String[] {"Hora est\u00e1ndar Central (Sur de Australia)", "CST",
						 "Hora de verano Central (Sur de Australia)", "CST"}},
	    {"Australia/Brisbane", new String[] {"Hora est\u00e1ndar Oriental (Queensland)", "EST",
						 "Hora de verano Oriental (Queensland)", "EST"}},
	    {"Australia/Broken_Hill", new String[] {"Hora est\u00e1ndar Central (Sur de Australia/Nueva Gales del Sur)", "CST",
						    "Hora de verano Central (Sur de Australia/Nueva Gales del Sur)", "CST"}},
	    {"Australia/Darwin", new String[] {"Hora est\u00e1ndar Central (Territorio del Norte)", "CST",
					       "Hora de verano Central (Territorio del Norte)", "CST"}},
	    {"Australia/Hobart", new String[] {"Hora est\u00e1ndar Oriental (Tasmania)", "EST",
					       "Hora de verano Oriental (Tasmania)", "EST"}},
	    {"Australia/Lord_Howe", new String[] {"Hora est\u00e1ndar de Lord Howe", "LHST",
						  "Hora de verano de Lord Howe", "LHST"}},
	    {"Australia/Perth", WST_AUS},
	    {"Australia/Sydney", EST_NSW},
	    {"BET", BRT},
	    {"BST", BDT},
	    {"CAT", CAT},
	    {"EAT", EAT},
	    {"EET", EET},
	    {"Europe/Amsterdam", CET},
	    {"Europe/Andorra", CET},
	    {"Europe/Athens", EET},
	    {"Europe/Belgrade", CET},
	    {"Europe/Berlin", CET},
	    {"Europe/Brussels", CET},
	    {"Europe/Budapest", CET},
	    {"Europe/Chisinau", EET},
	    {"Europe/Copenhagen", CET},
	    {"Europe/Dublin", new String[] {"Hora media de Greenwich", "GMT",
					    "Hora de verano de Irlanda", "IST"}},
	    {"Europe/Gibraltar", CET},
	    {"Europe/Helsinki", EET},
	    {"Europe/Istanbul", EET},
	    {"Europe/Kaliningrad", EET},
	    {"Europe/Kiev", EET},
	    {"Europe/Lisbon", WET},
	    {"Europe/London", new String[] {"Hora media de Greenwich", "GMT",
					    "Hora de verano brit\u00e1nica", "BST"}},
	    {"Europe/Luxembourg", CET},
	    {"Europe/Madrid", CET},
	    {"Europe/Malta", CET},
	    {"Europe/Minsk", EET},
	    {"Europe/Monaco", CET},
	    {"Europe/Moscow", new String[] {"Hora est\u00e1ndar de Mosc\u00fa", "MSK",
					    "Hora de verano de Mosc\u00fa", "MSD"}},
	    {"Europe/Oslo", CET},
	    {"Europe/Prague", CET},
	    {"Europe/Riga", EET},
	    {"Europe/Rome", CET},
	    {"Europe/Samara", new String[] {"Hora de Samara", "SAMT",
					    "Hora de verano de Samara", "SAMST"}},
	    {"Europe/Simferopol", EET},
	    {"Europe/Sofia", EET},
	    {"Europe/Stockholm", CET},
	    {"Europe/Tallinn", EET},
	    {"Europe/Tirane", CET},
	    {"Europe/Vaduz", CET},
	    {"Europe/Vienna", CET},
	    {"Europe/Vilnius", EET},
	    {"Europe/Warsaw", CET},
	    {"Europe/Zurich", CET},
	    {"IST", IST},
	    {"Indian/Antananarivo", EAT},
	    {"Indian/Chagos", new String[] {"Hora del Territorio del Oc\u00e9ano \u00cdndico", "IOT",
					    "Hora de verano del Territorio del Oc\u00e9ano \u00cdndico", "IOST"}},
	    {"Indian/Christmas", new String[] {"Hora de la isla de Christmas", "CXT",
					       "Hora de verano de la isla de Christmas", "CXST"}},
	    {"Indian/Cocos", new String[] {"Hora de las islas Cocos", "CCT",
					   "Hora de verano de las islas Cocos", "CCST"}},
	    {"Indian/Comoro", EAT},
	    {"Indian/Kerguelen", new String[] {"Hora de los Territorios Franceses del Sur y de la Ant\u00e1rtida", "TFT",
					       "Hora de verano de los Territorios Franceses del Sur y de la Ant\u00e1rtida", "TFST"}},
	    {"Indian/Mahe", new String[] {"Hora de Seychelles", "SCT",
					  "Hora de verano de Seychelles", "SCST"}},
	    {"Indian/Maldives", new String[] {"Hora de Maldivas", "MVT",
					      "Hora de verano de Maldivas", "MVST"}},
	    {"Indian/Mauritius", new String[] {"Hora de Mauricio", "MUT",
					       "Hora de verano de Mauricio", "MUST"}},
	    {"Indian/Mayotte", EAT},
	    {"Indian/Reunion", new String[] {"Hora de Reuni\u00f3n", "RET",
					     "Hora de verano de Reuni\u00f3n", "REST"}},
	    {"MET", IRT},
	    {"MIT", WST_SAMOA},
	    {"NET", ARMT},
	    {"NST", NZST},
	    {"PLT", PKT},
	    {"PRT", AST},
	    {"Pacific/Apia", WST_SAMOA},
	    {"Pacific/Auckland", NZST},
	    {"Pacific/Chatham", new String[] {"Hora est\u00e1ndar de Chatham", "CHAST",
					      "Hora de verano de Chatham", "CHADT"}},
	    {"Pacific/Easter", new String[] {"Hora de la isla de Pascua", "EAST",
					     "Hora de verano de la isla de Pascua", "EASST"}},
	    {"Pacific/Efate", new String[] {"Hora de Vanuatu", "VUT",
					    "Hora de verano de Vanuatu", "VUST"}},
	    {"Pacific/Enderbury", new String[] {"Hora de la isla Phoenix", "PHOT",
						"Hora de verano de la isla Phoenix", "PHOST"}},
	    {"Pacific/Fakaofo", new String[] {"Hora de Tokelau", "TKT",
					      "Hora de verano de Tokelau", "TKST"}},
	    {"Pacific/Fiji", new String[] {"Hora de Fiji", "FJT",
					   "Hora de verano de Fiji", "FJST"}},
	    {"Pacific/Funafuti", new String[] {"Hora de Tuvalu", "TVT",
					       "Hora de verano de Tuvalu", "TVST"}},
	    {"Pacific/Galapagos", new String[] {"Hora de Gal\u00e1pagos", "GALT",
						"Hora de verano de Gal\u00e1pagos", "GALST"}},
	    {"Pacific/Gambier", new String[] {"Hora de Gambier", "GAMT",
					      "Hora de verano de Gambier", "GAMST"}},
	    {"Pacific/Guadalcanal", SBT},
        {"Pacific/Guam", ChST},
        {"Pacific/Kiritimati", new String[] {"Hora de las islas Line", "LINT",
						 "Hora de verano de las islas Line", "LINST"}},
	    {"Pacific/Kosrae", new String[] {"Hora de Kosrae", "KOST",
					     "Hora de verano de Kosrae", "KOSST"}},
	    {"Pacific/Majuro", new String[] {"Hora de las islas Marshall", "MHT",
					     "Hora de verano de las islas Marshall", "MHST"}},
	    {"Pacific/Marquesas", new String[] {"Hora de Marquesas", "MART",
						"Hora de verano de Marquesas", "MARST"}},
	    {"Pacific/Nauru", new String[] {"Hora de Nauru", "NRT",
					    "Hora de verano de Nauru", "NRST"}},
	    {"Pacific/Niue", new String[] {"Hora de Niue", "NUT",
					   "Hora de verano de Niue", "NUST"}},
	    {"Pacific/Norfolk", new String[] {"Hora de Norfolk", "NFT",
					      "Hora de verano de Norfolk", "NFST"}},
	    {"Pacific/Noumea", new String[] {"Hora de Nueva Caledonia", "NCT",
					     "Hora de verano de Nueva Caledonia", "NCST"}},
	    {"Pacific/Pago_Pago", new String[] {"Hora est\u00e1ndar de Samoa", "SST",
						"Hora de verano de Samoa", "SDT"}},
	    {"Pacific/Palau", new String[] {"Hora de Palau", "PWT",
					    "Hora de verano de Palau", "PWST"}},
	    {"Pacific/Pitcairn", new String[] {"Hora est\u00e1ndar de Pitcairn", "PST",
					       "Hora de verano de Pitcairn", "PDT"}},
	    {"Pacific/Ponape", new String[] {"Hora de Ponape", "PONT",
					     "Hora de verano de Ponape", "PONST"}},
	    {"Pacific/Port_Moresby", new String[] {"Hora de Pap\u00faa-Nueva Guinea", "PGT",
						   "Hora de verano de Pap\u00faa-Nueva Guinea", "PGST"}},
	    {"Pacific/Rarotonga", new String[] {"Hora de las islas Cook", "CKT",
						"Hora de verano de las islas Cook", "CKST"}},
        {"Pacific/Saipan", ChST},
	    {"Pacific/Tahiti", new String[] {"Hora de Tahit\u00ed", "TAHT",
					     "Hora de verano de Tahit\u00ed", "TAHST"}},
	    {"Pacific/Tarawa", new String[] {"Hora de las islas Gilbert", "GILT",
					     "Hora de verano de las islas Gilbert", "GILST"}},
	    {"Pacific/Tongatapu", new String[] {"Hora de Tonga", "TOT",
						"Hora de verano de Tonga", "TOST"}},
	    {"Pacific/Truk", new String[] {"Hora de Truk", "TRUT",
					   "Hora de verano de Truk", "TRUST"}},
	    {"Pacific/Wake", new String[] {"Hora de Wake", "WAKT",
					   "Hora de verano de Wake", "WAKST"}},
	    {"Pacific/Wallis", new String[] {"Hora de Wallis y Futuna", "WFT",
					     "Hora de verano de Wallis y Futuna", "WFST"}},
	    {"SST", SBT},
	    {"UTC", new String[] {"Hora universal coordinada", "UTC",
			 	  "Hora universal coordinada", "UTC"}},
	    {"VST", ICT},
	    {"WET", WET},

            {"localPatternChars", "GyMdkHmsSEDFwWahKzZ"},
        };
    }
}



