/*
 * @(#)DateFormatZoneData_fr.java	1.33 03/05/09
 */

/*
 * Portions Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * (C) Copyright Taligent, Inc. 1996, 1997 - All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998 - All Rights Reserved
 *
 * The original version of this source code and documentation
 * is copyrighted and owned by Taligent, Inc., a wholly-owned
 * subsidiary of IBM. These materials are provided under terms
 * of a License Agreement between Taligent and Sun. This technology
 * is protected by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.text.resources;

/**
 * Supplement package private date-time formatting zone data for DateFormat.
 * DateFormatData used in DateFormat will be initialized by loading the data
 * from LocaleElements and DateFormatZoneData resources. The zone data are
 * represented with the following form:
 * {ID, new String[] {ID, long zone string, short zone string, long daylight
 * string, short daylight string, representative city of zone}}, where ID is
 * NOT localized, but is used to look up the localized timezone data
 * internally. Localizers can localize any zone strings except
 * for the ID of the timezone.
 * Also, localizer should not touch "localPatternChars" entry.
 *
 * @see          Format
 * @see          DateFormatData
/ * @see          LocaleElements
 * @see          SimpleDateFormat
 * @see          TimeZone
 * @version      1.23 08/05/01
 * @author       Chen-Lieh Huang
 */
//  German DateFormatZoneData
//
public final class DateFormatZoneData_fr extends DateFormatZoneData
{
    /**
     * Overrides DateFormatZoneData
     */
    public Object[][] getContents() {
	String ACT[] = new String[] {"Heure de l'Acre", "ACT",
				     "Heure d'\u00e9t\u00e9 de l'Acre", "ACST"};
	String AGT[] = new String[] {"Heure de l'Argentine", "ART",
				     "Heure d'\u00e9t\u00e9 de l'Argentine", "ARST"} ;
	String AKST[] = new String[] {"Heure normale de l'Alaska", "AKST",
				      "Heure avanc\u00e9e de l'Alaska", "AKDT"} ;
	String AMT[] = new String[] {"Heure normale de l'Amazonie", "AMT",
				     "Heure d'\u00e9t\u00e9 de l'Amazonie", "AMST"} ;
	String ARAST[] = new String[] {"Heure normale de l'Arabie", "AST",
				       "Heure avanc\u00e9e de l'Arabie", "ADT"} ;
	String ARMT[] = new String[] {"Heure de l'Arm\u00e9nie", "AMT",
				      "Heure d'\u00e9t\u00e9 de l'Arm\u00e9nie", "AMST"} ;
	String AST[] = new String[] {"Heure normale de l'Atlantique", "AST",
				     "Heure avanc\u00e9e de l'Atlantique", "ADT"} ;
	String BDT[] = new String[] {"Heure du Bangladesh", "BDT",
				     "Heure d'\u00e9t\u00e9 du Bangladesh", "BDST"} ;
	String BRT[] = new String[] {"Heure du Br\u00e9sil", "BRT",
				     "Heure d'\u00e9t\u00e9 du Br\u00e9sil", "BRST"} ;
	String BTT[] = new String[] {"Heure du Bhoutan", "BTT",
				     "Heure d'\u00e9t\u00e9 du Bhoutan", "BTST"} ;
	String CAT[] = new String[] {"Heure d'Afrique centrale", "CAT",
				     "Heure d'\u00e9t\u00e9 d'Afrique centrale", "CAST"} ;
	String CET[] = new String[] {"Heure d'Europe centrale", "CET",
				     "Heure d'\u00e9t\u00e9 d'Europe centrale", "CEST"} ;
	String CIT[] = new String[] {"Heure d'Indon\u00e9sie centrale", "CIT",
				     "Heure d'\u00e9t\u00e9 d'Indon\u00e9sie centrale", "CIST"};
	String CLT[] = new String[] {"Heure du Chili", "CLT",
				     "Heure d'\u00e9t\u00e9 du Chili", "CLST"} ;
	String CST[] = new String[] {"Heure normale du Centre", "CST",
				     "Heure avanc\u00e9e du Centre", "CDT"} ;
	String CTT[] = new String[] {"Heure normale de Chine", "CST",
				     "Heure avanc\u00e9e de Chine", "CDT"} ;
	String EAT[] = new String[] {"Heure d'Afrique de l'Est", "EAT",
				     "Heure d'\u00e9t\u00e9 d'Afrique de l'Est", "EAST"} ;
	String EET[] = new String[] {"Heure d'Europe de l'Est", "EET",
				     "Heure d'\u00e9t\u00e9 d'Europe de l'Est", "EEST"} ;
	String EGT[] = new String[] {"Heure du Groenland de l'Est", "EGT",
				     "Heure d'\u00e9t\u00e9 du Groenland de l'Est", "EGST"} ;
	String EST[] = new String[] {"Heure normale de l'Est", "EST",
				     "Heure avanc\u00e9e de l'Est", "EDT"} ;
	String EST_NSW[] = new String[] {"Heure normale de l'Est (Nouvelle-Galles du Sud)", "EST",
					 "Heure d'\u00e9t\u00e9 de l'Est (Nouvelle-Galles du Sud)", "EST"} ;
	String GMT[] = new String[] {"Heure de Greenwich", "GMT",
				   "Heure de Greenwich", "GMT"} ;
	String GST[] = new String[] {"Heure normale du Golfe", "GST",
				     "Heure avanc\u00e9e du Golfe", "GDT"} ;
	String HAST[] = new String[] {"Heure normale d'Hawa\u00ef-Al\u00e9outiennes", "HAST",
				      "Heure avanc\u00e9e d'Hawa\u00ef-Al\u00e9outiennes", "HADT"} ;
	String HST[] = new String[] {"Heure normale d'Hawa\u00ef", "HST",
				     "Heure avanc\u00e9e d'Hawa\u00ef", "HDT"} ;
	String ICT[] = new String[] {"Heure d'Indochine", "ICT",
				     "Heure d'\u00e9t\u00e9 d'Indochine", "ICST"} ;
	String IRT[] = new String[] {"Heure normale de l'Iran", "IRST",
				     "Heure avanc\u00e9e de l'Iran", "IRDT"} ;
	String IST[] = new String[] {"Heure normale de l'Inde", "IST",
				     "Heure avanc\u00e9e de l'Inde", "IDT"} ;
	String JST[] = new String[] {"Heure normale du Japon", "JST",
				     "Heure avanc\u00e9e du Japon", "JDT"} ;
	String KST[] = new String[] {"Heure normale de Cor\u00e9e", "KST",
				     "Heure avanc\u00e9e de Cor\u00e9e", "KDT"} ;
	String MST[] = new String[] {"Heure normale des Rocheuses", "MST",
				     "Heure avanc\u00e9e des Rocheuses", "MDT"} ;
	String NST[] = new String[] {"Heure normale de Terre-Neuve", "NST",
				     "Heure avanc\u00e9e de Terre-Neuve", "NDT"} ;
	String NZST[] = new String[] {"Heure normale de Nouvelle-Z\u00e9lande", "NZST",
				      "Heure avanc\u00e9e de Nouvelle-Z\u00e9lande", "NZDT"} ;
	String PKT[] = new String[] {"Heure du Pakistan", "PKT",
				     "Heure d'\u00e9t\u00e9 du Pakistan", "PKST"} ;
	String PST[] = new String[] {"Heure normale du Pacifique", "PST",
				     "Heure avanc\u00e9e du Pacifique", "PDT"} ;
	String SAST[] = new String[] {"Heure normale d'Afrique du Sud", "SAST",
				      "Heure d'\u00e9t\u00e9 d'Afrique du Sud", "SAST"} ;
	String SBT[] = new String[] {"Heure des \u00celes Salomon", "SBT",
				     "Heure d'\u00e9t\u00e9 des \u00celes Salomon", "SBST"} ;
	String TMT[] = new String[] {"Heure du Turkm\u00e9nistan", "TMT",
				     "Heure d'\u00e9t\u00e9 du Turkm\u00e9nistan", "TMST"} ;
	String ULAT[]= new String[] {"Heure de l'Ulaanbaatar", "ULAT",
				     "Heure d'\u00e9t\u00e9 de l'Ulaanbaatar", "ULAST"} ;
	String WAT[] = new String[] {"Heure d'Afrique de l'Ouest", "WAT",
				     "Heure d'\u00e9t\u00e9 d'Afrique de l'Ouest", "WAST"} ;
	String WET[] = new String[] {"Heure d'Europe de l'Ouest", "WET",
				     "Heure d'\u00e9t\u00e9 d'Europe de l'Ouest", "WEST"} ;
	String WST_AUS[] = new String[] {"Heure normale de l'Ouest (Australie)", "WST",
					 "Heure d'\u00e9t\u00e9 de l'Ouest (Australie)", "WST"} ;
	String WST_SAMOA[] = new String[] {"Heure des Samoas occidentales", "WST",
					   "Heure d'\u00e9t\u00e9 des Samoas occidentales", "WSST"} ;
	String ChST[] = new String[] {"Heure normale des \u00eeles Mariannes", "ChST",
                      "Heure d'\u00e9t\u00e9 des \u00eeles Mariannes", "ChDT"};

	return new Object[][] {
	    {"PST", PST},
	    {"America/Los_Angeles", PST},
	    {"MST", MST},
	    {"America/Denver", MST},
	    {"PNT", MST},
	    {"America/Phoenix", MST},
	    {"CST", CST},
	    {"America/Chicago", CST},
	    {"EST", EST},
	    {"America/New_York", EST},
	    {"IET", EST},
	    {"America/Indianapolis", EST},
	    {"HST", HST},
	    {"Pacific/Honolulu", HST},
	    {"AST", AKST},
	    {"America/Anchorage", AKST},
	    {"America/Halifax", AST},
	    {"CNT", NST},
	    {"America/St_Johns", NST},
	    {"ECT", CET},
	    {"Europe/Paris", CET},
	    {"GMT", GMT},
	    {"Africa/Casablanca", WET},
	    {"Asia/Jerusalem", new String[] {"Heure normale d'Isra\u00ebl", "IST",
					     "Heure avanc\u00e9e d'Isra\u00ebl", "IDT"}},
	    {"JST", JST},
	    {"Asia/Tokyo", JST},
	    {"Europe/Bucharest", EET},
	    {"CTT", CTT},
	    {"Asia/Shanghai", CTT},
	    /* Don't change the order of the above zones
	     * to keep compatibility with the previous version.
	     */

	    {"ACT", new String[] {"Heure normale du Centre (Territoire du Nord)", "CST",
				  "Heure avanc\u00e9e du Centre (Territoire du Nord)", "CDT"}},
	    {"AET", EST_NSW},
	    {"AGT", AGT},
	    {"ART", EET},
	    {"Africa/Abidjan", GMT},
	    {"Africa/Accra", GMT},
	    {"Africa/Addis_Ababa", EAT},
	    {"Africa/Algiers", CET},
	    {"Africa/Asmera", EAT},
	    {"Africa/Bangui", WAT},
	    {"Africa/Banjul", GMT},
	    {"Africa/Bissau", GMT},
	    {"Africa/Blantyre", CAT},
	    {"Africa/Bujumbura", CAT},
            {"Africa/Cairo", EET},
	    {"Africa/Conakry", GMT},
	    {"Africa/Dakar", GMT},
	    {"Africa/Dar_es_Salaam", EAT},
	    {"Africa/Djibouti", EAT},
	    {"Africa/Douala", WAT},
	    {"Africa/Freetown", GMT},
	    {"Africa/Gaborone", CAT},
	    {"Africa/Harare", CAT},
	    {"Africa/Johannesburg", SAST},
	    {"Africa/Kampala", EAT},
	    {"Africa/Khartoum", EAT},
	    {"Africa/Kigali", CAT},
	    {"Africa/Kinshasa", WAT},
	    {"Africa/Lagos", WAT},
	    {"Africa/Libreville", WAT},
	    {"Africa/Lome", GMT},
	    {"Africa/Luanda", WAT},
	    {"Africa/Lubumbashi", CAT},
	    {"Africa/Lusaka", CAT},
	    {"Africa/Malabo", WAT},
	    {"Africa/Maputo", CAT},
	    {"Africa/Maseru", SAST},
	    {"Africa/Mbabane", SAST},
	    {"Africa/Mogadishu", EAT},
	    {"Africa/Monrovia", GMT},
	    {"Africa/Nairobi", EAT},
	    {"Africa/Ndjamena", WAT},
	    {"Africa/Niamey", WAT},
	    {"Africa/Nouakchott", GMT},
	    {"Africa/Ouagadougou", GMT},
	    {"Africa/Porto-Novo", WAT},
	    {"Africa/Sao_Tome", GMT},
	    {"Africa/Timbuktu", GMT},
	    {"Africa/Tripoli", EET},
	    {"Africa/Tunis", CET},
	    {"Africa/Windhoek", WAT},
	    {"America/Adak", HAST},
	    {"America/Anguilla", AST},
	    {"America/Antigua", AST},
	    {"America/Aruba", AST},
	    {"America/Asuncion", new String[] {"Heure du Paraguay", "PYT",
					       "Heure d'\u00e9t\u00e9 du Paraguay", "PYST"}},
	    {"America/Barbados", AST},
	    {"America/Belize", CST},
	    {"America/Bogota", new String[] {"Heure de Colombie", "COT",
					     "Heure d'\u00e9t\u00e9 de Colombie", "COST"}},
	    {"America/Buenos_Aires", AGT},
	    {"America/Caracas", new String[] {"Heure du Venezuela", "VET",
					      "Heure d'\u00e9t\u00e9 du Venezuela", "VEST"}},
	    {"America/Cayenne", new String[] {"Heure de la Guyane fran\u00e7aise", "GFT",
					      "Heure d'\u00e9t\u00e9 de la Guyane fran\u00e7aise", "GFST"}},
	    {"America/Cayman", EST},
	    {"America/Costa_Rica", CST},
	    {"America/Cuiaba", AMT},
	    {"America/Curacao", AST},
	    {"America/Dawson_Creek", MST},
	    {"America/Dominica", AST},
	    {"America/Edmonton", MST},
	    {"America/El_Salvador", CST},
	    {"America/Fortaleza", BRT},
	    {"America/Godthab", new String[] {"Heure du Groenland de l'Ouest", "WGT",
					      "Heure d'\u00e9t\u00e9 du Groenland de l'Ouest", "WGST"}},
	    {"America/Grand_Turk", EST},
	    {"America/Grenada", AST},
	    {"America/Guadeloupe", AST},
	    {"America/Guatemala", CST},
	    {"America/Guayaquil", new String[] {"Heure de l'\u00c9quateur", "ECT",
						"Heure d'\u00e9t\u00e9 de l'\u00c9quateur", "ECST"}},
	    {"America/Guyana", new String[] {"Heure de Guyana", "GYT",
					     "Heure d'\u00e9t\u00e9 de Guyana", "GYST"}},
	    {"America/Havana", CST},
	    {"America/Jamaica", EST},
	    {"America/La_Paz", new String[] {"Heure de Bolivie", "BOT",
					     "Heure d'\u00e9t\u00e9 de Bolivie", "BOST"}},
	    {"America/Lima", new String[] {"Heure du P\u00e9rou", "PET",
					   "Heure d'\u00e9t\u00e9 du P\u00e9rou", "PEST"}},
	    {"America/Managua", CST},
	    {"America/Manaus", AMT},
	    {"America/Martinique", AST},
	    {"America/Mazatlan", MST},
	    {"America/Mexico_City", CST},
	    {"America/Miquelon", new String[] {"Heure normale de Saint-Pierre et Miquelon", "PMST",
					       "Heure avanc\u00e9e de Saint-Pierre et Miquelon", "PMDT"}},
	    {"America/Montevideo", new String[] {"Heure de l'Uruguay", "UYT",
						 "Heure d'\u00e9t\u00e9 de l'Uruguay", "UYST"}},
	    {"America/Montreal", EST},
	    {"America/Montserrat", AST},
	    {"America/Nassau", EST},
	    {"America/Noronha", new String[] {"Heure de Fernando de Noronha", "FNT",
					      "Heure d'\u00e9t\u00e9 de Fernando de Noronha", "FNST"}},
	    {"America/Panama", EST},
	    {"America/Paramaribo", new String[] {"Heure du Surinam", "SRT",
						 "Heure d'\u00e9t\u00e9 du Surinam", "SRST"}},
	    {"America/Port-au-Prince", EST},
	    {"America/Port_of_Spain", AST},
	    {"America/Porto_Acre", ACT},
	    {"America/Puerto_Rico", AST},
	    {"America/Regina", CST},
	    {"America/Rio_Branco", ACT},
	    {"America/Santiago", CLT},
	    {"America/Santo_Domingo", AST},
	    {"America/Sao_Paulo", BRT},
	    {"America/Scoresbysund", EGT},
	    {"America/St_Kitts", AST},
	    {"America/St_Lucia", AST},
	    {"America/St_Thomas", AST},
	    {"America/St_Vincent", AST},
	    {"America/Tegucigalpa", CST},
	    {"America/Thule", AST},
	    {"America/Tijuana", PST},
	    {"America/Tortola", AST},
	    {"America/Vancouver", PST},
	    {"America/Winnipeg", CST},
	    {"Antarctica/Casey", WST_AUS},
	    {"Antarctica/DumontDUrville", new String[] {"Heure de Dumont-d'Urville", "DDUT",
							"Heure d'\u00e9t\u00e9 de Dumont-d'Urville", "DDUST"}},
	    {"Antarctica/Mawson", new String[] {"Heure de Mawson", "MAWT",
						"Heure d'\u00e9t\u00e9 de Mawson", "MAWST"}},
	    {"Antarctica/McMurdo", NZST},
	    {"Antarctica/Palmer", CLT},
	    {"Antarctica/Rothera", new String[] {"Heure de Rothera", "ROTT",
						 "Heure d'\u00e9t\u00e9 de Rothera", "ROTST"}},
	    {"Asia/Aden", ARAST},
	    {"Asia/Almaty", new String[] {"Heure d'Alma-Ata", "ALMT",
					  "Heure d'\u00e9t\u00e9 d'Alma-Ata", "ALMST"}},
	    {"Asia/Amman", EET},
	    {"Asia/Anadyr", new String[] {"Heure d'Anadyr", "ANAT",
					  "Heure d'\u00e9t\u00e9 d'Anadyr", "ANAST"}},
	    {"Asia/Aqtau", new String[] {"Heure d'Aqtau", "AQTT",
					 "Heure d'\u00e9t\u00e9 d'Aqtau", "AQTST"}},
	    {"Asia/Aqtobe", new String[] {"Heure d'Aqtobe", "AQTT",
					  "Heure d'\u00e9t\u00e9 d'Aqtobe", "AQTST"}},
	    {"Asia/Ashgabat", TMT},
	    {"Asia/Ashkhabad", TMT},
	    {"Asia/Baghdad", ARAST},
	    {"Asia/Bahrain", ARAST},
	    {"Asia/Baku", new String[] {"Heure d'Azerba\u00efdjan", "AZT",
					"Heure d'\u00e9t\u00e9 d'Azerba\u00efdjan", "AZST"}},
	    {"Asia/Bangkok", ICT},
	    {"Asia/Beirut", EET},
	    {"Asia/Bishkek", new String[] {"Heure du Kirghizistan", "KGT",
					   "Heure d'\u00e9t\u00e9 du Kirghizistan", "KGST"}},
	    {"Asia/Brunei", new String[] {"Heure du Brunei", "BNT",
					  "Heure d'\u00e9t\u00e9 du Brunei", "BNST"}},
	    {"Asia/Calcutta", IST},
	    {"Asia/Colombo", new String[] {"Heure du Sri Lanka", "LKT",
					   "Heure d'\u00e9t\u00e9 du Sri Lanka", "LKST"}},
	    {"Asia/Dacca", BDT},
	    {"Asia/Dhaka", BDT},
	    {"Asia/Damascus", EET},
	    {"Asia/Dubai", GST},
	    {"Asia/Dushanbe", new String[] {"Heure du Tadjikistan", "TJT",
					    "Heure d'\u00e9t\u00e9 du Tadjikistan", "TJST"}},
	    {"Asia/Hong_Kong", new String[] {"Heure de Hong Kong", "HKT",
					     "Heure d'\u00e9t\u00e9 de Hong Kong", "HKST"}},
	    {"Asia/Irkutsk", new String[] {"Heure de l'Irkutsk", "IRKT",
					   "Heure d'\u00e9t\u00e9 de l'Irkutsk", "IRKST"}},
            {"Asia/Jakarta", new String[] {"Heure d'Indon\u00e9sie occidentale", "WIT",
                                           "Heure d'\u00e9t\u00e9 d'Indon\u00e9sie occidentale", "WIST"}},
            {"Asia/Jayapura", new String[] {"Heure d'Indon\u00e9sie orientale", "EIT",
                                            "Heure d'\u00e9t\u00e9 d'Indon\u00e9sie orientale", "EIST"}},
	    {"Asia/Kabul", new String[] {"Heure d'Afghanistan", "AFT",
					 "Heure d'\u00e9t\u00e9 d'Afghanistan", "AFST"}},
	    {"Asia/Kamchatka", new String[] {"Heure de Petropavlovsk-Kamchatski", "PETT",
					     "Heure d'\u00e9t\u00e9 de Petropavlovsk-Kamchatski", "PETST"}},
	    {"Asia/Karachi", PKT},
	    {"Asia/Katmandu", new String[] {"Heure du N\u00e9pal", "NPT",
					    "Heure d'\u00e9t\u00e9 du N\u00e9pal", "NPST"}},
	    {"Asia/Krasnoyarsk", new String[] {"Heure de Krasno\u00efarsk", "KRAT",
					       "Heure d'\u00e9t\u00e9 de Krasno\u00efarsk", "KRAST"}},
	    {"Asia/Kuala_Lumpur", new String[] {"Heure de Malaisie", "MYT",
						"Heure d'\u00e9t\u00e9 de Malaisie", "MYST"}},
	    {"Asia/Kuwait", ARAST},
	    {"Asia/Macao", CTT},
	    {"Asia/Macau", CTT},
	    {"Asia/Magadan", new String[] {"Heure de Magadan", "MAGT",
					   "Heure d'\u00e9t\u00e9 de Magadan", "MAGST"}},
	    {"Asia/Makassar", CIT},
	    {"Asia/Manila", new String[] {"Heure des Philippines", "PHT",
					  "Heure d'\u00e9t\u00e9 des Philippines", "PHST"}},
	    {"Asia/Muscat", GST},
	    {"Asia/Nicosia", EET},
	    {"Asia/Novosibirsk", new String[] {"Heure de Novossibirsk", "NOVT",
					       "Heure d'\u00e9t\u00e9 de Novossibirsk", "NOVST"}},
	    {"Asia/Oral", new String[] {"Heure d'Oral", "ORAT",
					"Heure d'\u00e9t\u00e9 d'Oral", "ORAST"}},
	    {"Asia/Phnom_Penh", ICT},
	    {"Asia/Pyongyang", KST},
	    {"Asia/Qatar", ARAST},
	    {"Asia/Qyzylorda", new String[] {"Heure de Kyzylorda", "QYZT",
					     "Heure d'\u00e9t\u00e9 de Kyzylorda", "QYZST"}},
	    {"Asia/Rangoon", new String[] {"Heure de Myanmar", "MMT",
					   "Heure d'\u00e9t\u00e9 de Myanmar", "MMST"}},
	    {"Asia/Riyadh", ARAST},
	    {"Asia/Saigon", ICT},
	    {"Asia/Seoul", KST},
	    {"Asia/Singapore", new String[] {"Heure de Singapour", "SGT",
					     "Heure d'\u00e9t\u00e9 de Singapour", "SGST"}},
	    {"Asia/Taipei", CTT},
	    {"Asia/Tashkent", new String[] {"Heure d'Ouzb\u00e9kistan", "UZT",
					    "Heure d'\u00e9t\u00e9 d'Ouzb\u00e9kistan", "UZST"}},
	    {"Asia/Tbilisi", new String[] {"Heure de G\u00e9orgie", "GET",
					   "Heure d'\u00e9t\u00e9 de G\u00e9orgie", "GEST"}},
	    {"Asia/Tehran", IRT},
	    {"Asia/Thimbu", BTT},
	    {"Asia/Thimphu", BTT},
	    {"Asia/Ujung_Pandang", CIT},
	    {"Asia/Ulaanbaatar", ULAT},
	    {"Asia/Ulan_Bator", ULAT},
	    {"Asia/Vientiane", ICT},
	    {"Asia/Vladivostok", new String[] {"Heure de Vladivostok", "VLAT",
					       "Heure d'\u00e9t\u00e9 de Vladivostok", "VLAST"}},
	    {"Asia/Yakutsk", new String[] {"Heure du Iakoutsk", "YAKT",
					   "Heure d'\u00e9t\u00e9 du Iakoutsk", "YAKST"}},
	    {"Asia/Yekaterinburg", new String[] {"Heure de Yekaterinburg", "YEKT",
						 "Heure d'\u00e9t\u00e9 de Yekaterinburg", "YEKST"}},
	    {"Asia/Yerevan", ARMT},
	    {"Atlantic/Azores", new String[] {"Heure des A\u00e7ores", "AZOT",
					      "Heure d'\u00e9t\u00e9 des A\u00e7ores", "AZOST"}},
	    {"Atlantic/Bermuda", AST},
	    {"Atlantic/Canary", WET},
	    {"Atlantic/Cape_Verde", new String[] {"Heure de Cap-Vert", "CVT",
						  "Heure d'\u00e9t\u00e9 de Cap-Vert", "CVST"}},
	    {"Atlantic/Faeroe", WET},
	    {"Atlantic/Jan_Mayen", EGT},
	    {"Atlantic/Reykjavik", GMT},
	    {"Atlantic/South_Georgia", new String[] {"Heure normale de G\u00e9orgie du Sud", "GST",
						     "Heure avanc\u00e9e de G\u00e9orgie du Sud", "GDT"}},
	    {"Atlantic/St_Helena", GMT},
	    {"Atlantic/Stanley", new String[] {"Heure des \u00eeles Falkland", "FKT",
					       "Heure d'\u00e9t\u00e9 des \u00eeles Falkland", "FKST"}},
	    {"Australia/Adelaide", new String[] {"Heure normale du Centre (Australie du Sud)", "CST",
						 "Heure d'\u00e9t\u00e9 du Centre (Australie du Sud)", "CST"}},
	    {"Australia/Brisbane", new String[] {"Heure normale de l'Est (Queensland)", "EST",
						 "Heure d'\u00e9t\u00e9 de l'Est (Queensland)", "EST"}},
	    {"Australia/Broken_Hill", new String[] {"Heure normale du Centre (Australie du Sud/Nouvelles-Galles du Sud)", "CST",
						    "Heure d'\u00e9t\u00e9 du Centre (Australie du Sud/Nouvelles-Galles du Sud)", "CST"}},
	    {"Australia/Darwin", new String[] {"Heure normale du Centre (Territoire du Nord)", "CST",
					       "Heure d'\u00e9t\u00e9 du Centre (Territoire du Nord)", "CST"}},
	    {"Australia/Hobart", new String[] {"Heure normale de l'Est (Tasmanie)", "EST",
					       "Heure d'\u00e9t\u00e9 de l'Est (Tasmanie)", "EST"}},
	    {"Australia/Lord_Howe", new String[] {"Heure normale de Lord Howe", "LHST",
						  "Heure d'\u00e9t\u00e9 de Lord Howe", "LHST"}},
	    {"Australia/Perth", WST_AUS},
	    {"Australia/Sydney", EST_NSW},
	    {"BET", BRT},
	    {"BST", BDT},
	    {"CAT", CAT},
	    {"EAT", EAT},
	    {"EET", EET},
	    {"Europe/Amsterdam", CET},
	    {"Europe/Andorra", CET},
	    {"Europe/Athens", EET},
	    {"Europe/Belgrade", CET},
	    {"Europe/Berlin", CET},
	    {"Europe/Brussels", CET},
	    {"Europe/Budapest", CET},
	    {"Europe/Chisinau", EET},
	    {"Europe/Copenhagen", CET},
	    {"Europe/Dublin", new String[] {"Temps universel", "TU",
					    "Heure d'\u00e9t\u00e9 d'Irlande", "IST"}},
	    {"Europe/Gibraltar", CET},
	    {"Europe/Helsinki", EET},
	    {"Europe/Istanbul", EET},
	    {"Europe/Kaliningrad", EET},
	    {"Europe/Kiev", EET},
	    {"Europe/Lisbon", WET},
	    {"Europe/London", new String[] {"Temps universel", "TU",
					    "Heure d'\u00e9t\u00e9 du Royaume-Uni", "BST"}},
	    {"Europe/Luxembourg", CET},
	    {"Europe/Madrid", CET},
	    {"Europe/Malta", CET},
	    {"Europe/Minsk", EET},
	    {"Europe/Monaco", CET},
	    {"Europe/Moscow", new String[] {"Heure normale de Moscou", "MSK",
					    "Heure avanc\u00e9e de Moscou", "MSD"}},
	    {"Europe/Oslo", CET},
	    {"Europe/Prague", CET},
	    {"Europe/Riga", EET},
	    {"Europe/Rome", CET},
	    {"Europe/Samara", new String[] {"Heure normale de Samara", "SAMT",
					    "Heure d'\u00e9t\u00e9 de Samara", "SAMST"}},
	    {"Europe/Simferopol", EET},
	    {"Europe/Sofia", EET},
	    {"Europe/Stockholm", CET},
	    {"Europe/Tallinn", EET},
	    {"Europe/Tirane", CET},
	    {"Europe/Vaduz", CET},
	    {"Europe/Vienna", CET},
	    {"Europe/Vilnius", EET},
	    {"Europe/Warsaw", CET},
	    {"Europe/Zurich", CET},
	    {"IST", IST},
	    {"Indian/Antananarivo", EAT},
	    {"Indian/Chagos", new String[] {"Heure de l'oc\u00e9an Indien", "IOT",
					    "Heure d'\u00e9t\u00e9 de l'oc\u00e9an Indien", "IOST"}},
	    {"Indian/Christmas", new String[] {"Heure de l'\u00cele Christmas", "CXT",
					       "Heure d'\u00e9t\u00e9 de l'\u00cele Christmas", "CXST"}},
	    {"Indian/Cocos", new String[] {"Heure des \u00celes Cocos", "CCT",
					   "Heure d'\u00e9t\u00e9 des \u00celes Cocos", "CCST"}},
	    {"Indian/Comoro", EAT},
	    {"Indian/Kerguelen", new String[] {"Heure des Terres australes antartiques fran\u00e7aises", "TFT",
					       "Heure d'\u00e9t\u00e9 des Terres australes antartiques fran\u00e7aises", "TFST"}},
	    {"Indian/Mahe", new String[] {"Heure des Seychelles", "SCT",
					  "Heure d'\u00e9t\u00e9 des Seychelles", "SCST"}},
	    {"Indian/Maldives", new String[] {"Heure des Maldives", "MVT",
					      "Heure d'\u00e9t\u00e9 des Maldives", "MVST"}},
	    {"Indian/Mauritius", new String[] {"Heure de Maurice", "MUT",
					       "Heure d'\u00e9t\u00e9 de Maurice", "MUST"}},
	    {"Indian/Mayotte", EAT},
	    {"Indian/Reunion", new String[] {"Heure de la R\u00e9union", "RET",
					     "Heure d'\u00e9t\u00e9 de la R\u00e9union", "REST"}},
	    {"MET", IRT},
	    {"MIT", WST_SAMOA},
	    {"NET", ARMT},
	    {"NST", NZST},
	    {"PLT", PKT},
	    {"PRT", AST},
	    {"Pacific/Apia", WST_SAMOA},
	    {"Pacific/Auckland", NZST},
	    {"Pacific/Chatham", new String[] {"Heure normale de Chatham", "CHAST",
					      "Heure avanc\u00e9e de Chatham", "CHADT"}},
	    {"Pacific/Easter", new String[] {"Heure de l'\u00eele de P\u00e2ques", "EAST",
					     "Heure d'\u00e9t\u00e9 de l'\u00eele de P\u00e2ques", "EASST"}},
	    {"Pacific/Efate", new String[] {"Heure du Vanuatu", "VUT",
					    "Heure d'\u00e9t\u00e9 du Vanuatu", "VUST"}},
	    {"Pacific/Enderbury", new String[] {"Heure de l'\u00cele de Phoenix", "PHOT",
						"Heure d'\u00e9t\u00e9 de l'\u00cele de Phoenix", "PHOST"}},
	    {"Pacific/Fakaofo", new String[] {"Heure de Tokelau", "TKT",
					      "Heure d'\u00e9t\u00e9 de Tokelau", "TKST"}},
	    {"Pacific/Fiji", new String[] {"Heure de Fidji", "FJT",
					   "Heure d'\u00e9t\u00e9 de Fidji", "FJST"}},
	    {"Pacific/Funafuti", new String[] {"Heure de Tuvalu", "TVT",
					       "Heure d'\u00e9t\u00e9 de Tuvalu", "TVST"}},
	    {"Pacific/Galapagos", new String[] {"Heure des Galapagos", "GALT",
						"Heure d'\u00e9t\u00e9 des Galapagos", "GALST"}},
	    {"Pacific/Gambier", new String[] {"Heure de Gambier", "GAMT",
					      "Heure d'\u00e9t\u00e9 de Gambier", "GAMST"}},
	    {"Pacific/Guadalcanal", SBT},
	    {"Pacific/Guam", ChST},
	    {"Pacific/Kiritimati", new String[] {"Heure de l'\u00cele de Line", "LINT",
						 "Heure d'\u00e9t\u00e9 de l'\u00cele de Line", "LINST"}},
	    {"Pacific/Kosrae", new String[] {"Heure de Kusaie", "KOST",
					     "Heure d'\u00e9t\u00e9 de Kusaie", "KOSST"}},
	    {"Pacific/Majuro", new String[] {"Heure des \u00celes Marshall", "MHT",
					     "Heure d'\u00e9t\u00e9 des \u00eeles Marshall", "MHST"}},
	    {"Pacific/Marquesas", new String[] {"Heure des Marquises", "MART",
						"Heure d'\u00e9t\u00e9 des Marquises", "MARST"}},
	    {"Pacific/Nauru", new String[] {"Heure de Nauru", "NRT",
					    "Heure d'\u00e9t\u00e9 de Nauru", "NRST"}},
	    {"Pacific/Niue", new String[] {"Heure de Niue", "NUT",
					   "Heure d'\u00e9t\u00e9 de Niue", "NUST"}},
	    {"Pacific/Norfolk", new String[] {"Heure de Norfolk", "NFT",
					      "Heure d'\u00e9t\u00e9 de Norfolk", "NFST"}},
	    {"Pacific/Noumea", new String[] {"Heure de Nouvelle-Cal\u00e9donie", "NCT",
					     "Heure d'\u00e9t\u00e9 de Nouvelle-Cal\u00e9donie", "NCST"}},
	    {"Pacific/Pago_Pago", new String[] {"Heure normale des Samoa", "SST",
						"Heure avanc\u00e9e des Samoa", "SDT"}},
	    {"Pacific/Palau", new String[] {"Heure de Palaos", "PWT",
					    "Heure d'\u00e9t\u00e9 de Palaos", "PWST"}},
	    {"Pacific/Pitcairn", new String[] {"Heure normale de Pitcairn", "PST",
					       "Heure avanc\u00e9e de Pitcairn", "PDT"}},
	    {"Pacific/Ponape", new String[] {"Heure de Ponap\u00e9", "PONT",
					     "Heure d'\u00e9t\u00e9 de Ponap\u00e9", "PONST"}},
	    {"Pacific/Port_Moresby", new String[] {"Heure de Papouasie-Nouvelle-Guin\u00e9e", "PGT",
						   "Heure d'\u00e9t\u00e9 de de Papouasie-Nouvelle-Guin\u00e9e", "PGST"}},
	    {"Pacific/Rarotonga", new String[] {"Heure des \u00celes Cook", "CKT",
						"Heure d'\u00e9t\u00e9 des \u00celes Cook", "CKST"}},
            {"Pacific/Saipan", ChST},
            {"Pacific/Tahiti", new String[] {"Heure de Tahiti", "TAHT",
					     "Heure d'\u00e9t\u00e9 de Tahiti", "TAHST"}},
	    {"Pacific/Tarawa", new String[] {"Heure de Kiribati", "GILT",
					     "Heure d'\u00e9t\u00e9 de Kiribati", "GILST"}},
	    {"Pacific/Tongatapu", new String[] {"Heure de Tonga", "TOT",
						"Heure d'\u00e9t\u00e9 de Tonga", "TOST"}},
	    {"Pacific/Truk", new String[] {"Heure de Truk", "TRUT",
					   "Heure d'\u00e9t\u00e9 de Truk", "TRUST"}},
	    {"Pacific/Wake", new String[] {"Heure de Wake", "WAKT",
					   "Heure d'\u00e9t\u00e9 de Wake", "WAKST"}},
	    {"Pacific/Wallis", new String[] {"Heure de Wallis et Futuna", "WFT",
					     "Heure d'\u00e9t\u00e9 de Wallis et Futuna", "WFST"}},
	    {"SST", SBT},
	    {"UTC", new String[] {"Temps universel coordonn\u00e9", "TUC",
			 	  "Temps universel coordonn\u00e9", "TUC"}},
	    {"VST", ICT},
	    {"WET", WET},

            {"localPatternChars", "GyMdkHmsSEDFwWahKzZ"},
        };
    }
}



