/*
 * @(#)DateFormatZoneData_it.java	1.32 03/05/09
 */

/*
 * Portions Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * (C) Copyright Taligent, Inc. 1996, 1997 - All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998 - All Rights Reserved
 *
 * The original version of this source code and documentation
 * is copyrighted and owned by Taligent, Inc., a wholly-owned
 * subsidiary of IBM. These materials are provided under terms
 * of a License Agreement between Taligent and Sun. This technology
 * is protected by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.text.resources;

/**
 * Supplement package private date-time formatting zone data for DateFormat.
 * DateFormatData used in DateFormat will be initialized by loading the data
 * from LocaleElements and DateFormatZoneData resources. The zone data are
 * represented with the following form:
 * {ID, new String[] {ID, long zone string, short zone string, long daylight
 * string, short daylight string, representative city of zone}}, where ID is
 * NOT localized, but is used to look up the localized timezone data
 * internally. Localizers can localize any zone strings except
 * for the ID of the timezone.
 * Also, localizer should not touch "localPatternChars" entry.
 *
 * @see          Format
 * @see          DateFormatData
 * @see          LocaleElements
 * @see          SimpleDateFormat
 * @see          TimeZone
 * @version      1.23 08/05/01
 * @author       Chen-Lieh Huang
 */
//  Italian DateFormatZoneData
//
public final class DateFormatZoneData_it extends DateFormatZoneData
{
    /**
     * Overrides DateFormatZoneData
     */
    public Object[][] getContents() {
	String ACT[] = new String[] {"Ora Acre", "ACT",
				     "Ora estiva Acre", "ACST"};
	String AGT[] = new String[] {"Ora Argentina", "ART",
				     "Ora estiva Argentina", "ARST"};
	String AKST[] = new String[] {"Ora solare Alaska", "AKST",
				      "Ora legale Alaska", "AKDT"};
	String AMT[] = new String[] {"Ora solare Amazzonia", "AMT",
				     "Ora estiva Amazzonia", "AMST"};
	String ARAST[] = new String[] {"Ora solare Arabia", "AST",
				       "Ora legale Arabia", "ADT"};
	String ARMT[] = new String[] {"Ora Armenia", "AMT",
				      "Ora estiva Armenia", "AMST"};
	String AST[] = new String[] {"Ora solare Atlantico occidentale", "AST",
				     "Ora legale Atlantico occidentale", "ADT"};
	String BDT[] = new String[] {"Ora Bangladesh", "BDT",
				     "Ora estiva Bangladesh", "BDST"};
	String BRT[] = new String[] {"Ora Brasile", "BRT",
				     "Ora estiva Brasile", "BRST"};
	String BTT[] = new String[] {"Ora Bhutan", "BTT",
				     "Ora estiva Bhutan", "BTST"};
	String CAT[] = new String[] {"Ora Africa centrale", "CAT",
				     "Ora estiva Africa centrale", "CAST"};
	String CET[] = new String[] {"Ora Europa centrale", "CET",
				     "Ora estiva Europa centrale", "CEST"};
	String CIT[] = new String[] {"Ora Indonesia centrale", "CIT",
				     "Ora estiva Indonesia centrale", "CIST"};
	String CLT[] = new String[] {"Ora Cile", "CLT",
				     "Ora estiva Cile", "CLST"};
	String CST[] = new String[] {"Ora solare USA centrali", "CST",
				     "Ora legale USA centrali", "CDT"};
	String CTT[] = new String[] {"Ora solare Cina", "CST",
				     "Ora legale Cina", "CDT"};
	String EAT[] = new String[] {"Ora Africa orientale", "EAT",
				     "Ora estiva Africa orientale", "EAST"};
	String EET[] = new String[] {"Ora Europa orientale", "EET",
				     "Ora estiva Europa orientale", "EEST"};
	String EGT[] = new String[] {"Ora Groenlandia orientale", "EGT",
				     "Ora estiva Groenlandia orientale", "EGST"};
	String EST[] = new String[] {"Ora solare USA orientali", "EST",
				     "Ora legale USA orientali", "EDT"};
	String EST_NSW[] = new String[] {"Ora solare Australia orientale (Nuovo Galles del Sud)", "EST",
					 "Ora estiva Australia orientale (Nuovo Galles del Sud)", "EST"};
	String GMT[] = new String[] {"Ora media di Greenwich", "GMT",
				   "Ora media di Greenwich", "GMT"};
	String GST[] = new String[] {"Ora solare del golfo", "GST",
				     "Ora legale del golfo", "GDT"};
	String HAST[] = new String[] {"Ora solare Isole Hawaii-Aleutine", "HAST",
				      "Ora solare Isole Hawaii-Aleutine", "HADT"};
	String HST[] = new String[] {"Ora solare Isole Hawaii", "HST",
				     "Ora legale Isole Hawaii", "HDT"};
	String ICT[] = new String[] {"Ora Indocina", "ICT",
				     "Ora estiva Indocina", "ICST"};
	String IRT[] = new String[] {"Ora solare Iran", "IRST",
				     "Ora legale Iran", "IRDT"};
	String IST[] = new String[] {"Ora solare India", "IST",
				     "Ora legale India", "IDT"};
	String JST[] = new String[] {"Ora solare Giappone", "JST",
				     "Ora legale Giappone", "JDT"};
	String KST[] = new String[] {"Ora solare Corea", "KST",
				     "Ora legale Corea", "KDT"};
	String MST[] = new String[] {"Ora solare USA occidentali", "MST",
				     "Ora legale USA occidentali", "MDT"};
	String NST[] = new String[] {"Ora solare Terranova", "NST",
				     "Ora legale Terranova", "NDT"};
	String NZST[] = new String[] {"Ora solare Nuova Zelanda", "NZST",
				      "Ora legale Nuova Zelanda", "NZDT"};
	String PKT[] = new String[] {"Ora Pakistan", "PKT",
				     "Ora estiva Pakistan", "PKST"};
	String PST[] = new String[] {"Ora solare costa occidentale USA", "PST",
				     "Ora legale costa occidentale USA", "PDT"};
	String SAST[] = new String[] {"Ora solare Sudafrica", "SAST",
				      "Ora estiva Sudafrica", "SAST"};
	String SBT[] = new String[] {"Ora Isole Salomone", "SBT",
				     "Ora estiva Isole Salomone", "SBST"};
	String TMT[] = new String[] {"Ora Turkmenistan", "TMT",
				     "Ora estiva Turkmenistan", "TMST"};
	String ULAT[]= new String[] {"Ora di Ulaanbaatar", "ULAT",
				     "Ora estiva di Ulaanbaatar", "ULAST"};
	String WAT[] = new String[] {"Ora Africa occidentale", "WAT",
				     "Ora estiva Africa occidentale", "WAST"};
	String WET[] = new String[] {"Ora Europa occidentale", "WET",
				     "Ora estiva Europa occidentale", "WEST"};
	String WST_AUS[] = new String[] {"Ora solare Australia occidentale", "WST",
					 "Ora estiva Australia occidentale", "WST"};
	String WST_SAMOA[] = new String[] {"Ora Samoa", "WST",
					   "Ora estiva Samoa", "WSST"};
	String ChST[] = new String[] {"Chamorro Standard Time", "ChST",
	                      "Chamorro Daylight Time", "ChDT"};

	return new Object[][] {
	    {"PST", PST},
	    {"America/Los_Angeles", PST},
	    {"MST", MST},
	    {"America/Denver", MST},
	    {"PNT", MST},
	    {"America/Phoenix", MST},
	    {"CST", CST},
	    {"America/Chicago", CST},
	    {"EST", EST},
	    {"America/New_York", EST},
	    {"IET", EST},
	    {"America/Indianapolis", EST},
	    {"HST", HST},
	    {"Pacific/Honolulu", HST},
	    {"AST", AKST},
	    {"America/Anchorage", AKST},
	    {"America/Halifax", AST},
	    {"CNT", NST},
	    {"America/St_Johns", NST},
	    {"ECT", CET},
	    {"Europe/Paris", CET},
	    {"GMT", GMT},
	    {"Africa/Casablanca", WET},
	    {"Asia/Jerusalem", new String[] {"Ora solare Israele", "IST",
					     "Ora legale Israele", "IDT"}},
	    {"JST", JST},
	    {"Asia/Tokyo", JST},
	    {"Europe/Bucharest", EET},
	    {"CTT", CTT},
	    {"Asia/Shanghai", CTT},
	    /* Don't change the order of the above zones
	     * to keep compatibility with the previous version.
	     */

	    {"ACT", new String[] {"Ora solare Australia centrale (Territorio del Nord)", "CST",
				  "Ora legale Australia centrale (Territorio del Nord)", "CDT"}},
	    {"AET", EST_NSW},
	    {"AGT", AGT},
	    {"ART", EET},
	    {"Africa/Abidjan", GMT},
	    {"Africa/Accra", GMT},
	    {"Africa/Addis_Ababa", EAT},
	    {"Africa/Algiers", CET},
	    {"Africa/Asmera", EAT},
	    {"Africa/Bangui", WAT},
	    {"Africa/Banjul", GMT},
	    {"Africa/Bissau", GMT},
	    {"Africa/Blantyre", CAT},
	    {"Africa/Bujumbura", CAT},
	    {"Africa/Cairo", EET},
	    {"Africa/Conakry", GMT},
	    {"Africa/Dakar", GMT},
	    {"Africa/Dar_es_Salaam", EAT},
	    {"Africa/Djibouti", EAT},
	    {"Africa/Douala", WAT},
	    {"Africa/Freetown", GMT},
	    {"Africa/Gaborone", CAT},
	    {"Africa/Harare", CAT},
	    {"Africa/Johannesburg", SAST},
	    {"Africa/Kampala", EAT},
	    {"Africa/Khartoum", EAT},
	    {"Africa/Kigali", CAT},
	    {"Africa/Kinshasa", WAT},
	    {"Africa/Lagos", WAT},
	    {"Africa/Libreville", WAT},
	    {"Africa/Lome", GMT},
	    {"Africa/Luanda", WAT},
	    {"Africa/Lubumbashi", CAT},
	    {"Africa/Lusaka", CAT},
	    {"Africa/Malabo", WAT},
	    {"Africa/Maputo", CAT},
	    {"Africa/Maseru", SAST},
	    {"Africa/Mbabane", SAST},
	    {"Africa/Mogadishu", EAT},
	    {"Africa/Monrovia", GMT},
	    {"Africa/Nairobi", EAT},
	    {"Africa/Ndjamena", WAT},
	    {"Africa/Niamey", WAT},
	    {"Africa/Nouakchott", GMT},
	    {"Africa/Ouagadougou", GMT},
	    {"Africa/Porto-Novo", WAT},
	    {"Africa/Sao_Tome", GMT},
	    {"Africa/Timbuktu", GMT},
	    {"Africa/Tripoli", EET},
	    {"Africa/Tunis", CET},
	    {"Africa/Windhoek", WAT},
	    {"America/Adak", HAST},
	    {"America/Anguilla", AST},
	    {"America/Antigua", AST},
	    {"America/Aruba", AST},
	    {"America/Asuncion", new String[] {"Ora Paraguay", "PYT",
					       "Ora estiva Paraguay", "PYST"}},
	    {"America/Barbados", AST},
	    {"America/Belize", CST},
	    {"America/Bogota", new String[] {"Ora Colombia", "COT",
					     "Ora estiva Colombia", "COST"}},
	    {"America/Buenos_Aires", AGT},
	    {"America/Caracas", new String[] {"Ora Venezuela", "VET",
					      "Ora estiva Venezuela", "VEST"}},
	    {"America/Cayenne", new String[] {"Ora Guayana Francese", "GFT",
					      "Ora estiva Guayana Francese", "GFST"}},
	    {"America/Cayman", EST},
	    {"America/Costa_Rica", CST},
	    {"America/Cuiaba", AMT},
	    {"America/Curacao", AST},
	    {"America/Dawson_Creek", MST},
	    {"America/Dominica", AST},
	    {"America/Edmonton", MST},
	    {"America/El_Salvador", CST},
	    {"America/Fortaleza", BRT},
	    {"America/Godthab", new String[] {"Ora Groenlandia occidentale", "WGT",
					      "Ora estiva Groenlandia occidentale", "WGST"}},
	    {"America/Grand_Turk", EST},
	    {"America/Grenada", AST},
	    {"America/Guadeloupe", AST},
	    {"America/Guatemala", CST},
	    {"America/Guayaquil", new String[] {"Ora Ecuador", "ECT",
						"Ora estiva Ecuador", "ECST"}},
	    {"America/Guyana", new String[] {"Ora Guyana", "GYT",
					     "Ora estiva Guyana", "GYST"}},
	    {"America/Havana", CST},
	    {"America/Jamaica", EST},
	    {"America/La_Paz", new String[] {"Ora Bolivia", "BOT",
					     "Ora estiva Bolivia", "BOST"}},
	    {"America/Lima", new String[] {"Ora Per\u00f9", "PET",
					   "Ora estiva Per\u00f9", "PEST"}},
	    {"America/Managua", CST},
	    {"America/Manaus", AMT},
	    {"America/Martinique", AST},
	    {"America/Mazatlan", MST},
	    {"America/Mexico_City", CST},
	    {"America/Miquelon", new String[] {"Ora solare Saint-Pierre e Miquelon", "PMST",
					       "Ora legale Saint-Pierre e Miquelon", "PMDT"}},
	    {"America/Montevideo", new String[] {"Ora Uruguay", "UYT",
						 "Ora estiva Uruguay", "UYST"}},
	    {"America/Montreal", EST},
	    {"America/Montserrat", AST},
	    {"America/Nassau", EST},
	    {"America/Noronha", new String[] {"Ora Territorio di Fernando de Noronha", "FNT",
					      "Ora estiva Territorio di Fernando de Noronha", "FNST"}},
	    {"America/Panama", EST},
	    {"America/Paramaribo", new String[] {"Ora Suriname", "SRT",
						 "Ora estiva Suriname", "SRST"}},
	    {"America/Port-au-Prince", EST},
	    {"America/Port_of_Spain", AST},
	    {"America/Porto_Acre", ACT},
	    {"America/Puerto_Rico", AST},
	    {"America/Regina", CST},
	    {"America/Rio_Branco", ACT},
	    {"America/Santiago", CLT},
	    {"America/Santo_Domingo", AST},
	    {"America/Sao_Paulo", BRT},
	    {"America/Scoresbysund", EGT},
	    {"America/St_Kitts", AST},
	    {"America/St_Lucia", AST},
	    {"America/St_Thomas", AST},
	    {"America/St_Vincent", AST},
	    {"America/Tegucigalpa", CST},
	    {"America/Thule", AST},
	    {"America/Tijuana", PST},
	    {"America/Tortola", AST},
	    {"America/Vancouver", PST},
	    {"America/Winnipeg", CST},
	    {"Antarctica/Casey", WST_AUS},
	    {"Antarctica/DumontDUrville", new String[] {"Ora di Dumont-d'Urville", "DDUT",
							"Ora estiva di Dumont-d'Urville", "DDUST"}},
	    {"Antarctica/Mawson", new String[] {"Ora di Mawson", "MAWT",
						"Ora estiva di Mawson", "MAWST"}},
	    {"Antarctica/McMurdo", NZST},
	    {"Antarctica/Palmer", CLT},
	    {"Antarctica/Rothera", new String[] {"Ora Rothera", "ROTT",
						 "Ora estiva Rothera", "ROTST"}},
	    {"Asia/Aden", ARAST},
	    {"Asia/Almaty", new String[] {"Ora di Alma-Ata", "ALMT",
					  "Ora estiva di Alma-Ata", "ALMST"}},
	    {"Asia/Amman", EET},
	    {"Asia/Anadyr", new String[] {"Ora di Anadyr", "ANAT",
					  "Ora estiva di Anadyr", "ANAST"}},
	    {"Asia/Aqtau", new String[] {"Ora di Aqtau", "AQTT",
					 "Ora estiva di Aqtau", "AQTST"}},
	    {"Asia/Aqtobe", new String[] {"Ora di Aqtobe", "AQTT",
					  "Ora estiva di Aqtobe", "AQTST"}},
	    {"Asia/Ashgabat", TMT},
	    {"Asia/Ashkhabad", TMT},
	    {"Asia/Baghdad", ARAST},
	    {"Asia/Bahrain", ARAST},
	    {"Asia/Baku", new String[] {"Ora Azerbaigian", "AZT",
					"ora estiva Azerbaigian", "AZST"}},
	    {"Asia/Bangkok", ICT},
	    {"Asia/Beirut", EET},
	    {"Asia/Bishkek", new String[] {"Ora Kirghizistan", "KGT",
					   "Ora estiva Kirghizistan", "KGST"}},
	    {"Asia/Brunei", new String[] {"Ora Brunei", "BNT",
					  "Ora estiva Brunei", "BNST"}},
	    {"Asia/Calcutta", IST},
	    {"Asia/Colombo", new String[] {"Ora Sri Lanka", "LKT",
					   "Ora estiva Sri Lanka", "LKST"}},
	    {"Asia/Dacca", BDT},
	    {"Asia/Dhaka", BDT},
	    {"Asia/Damascus", EET},
	    {"Asia/Dubai", GST},
	    {"Asia/Dushanbe", new String[] {"Ora Tagikistan", "TJT",
					    "Ora estiva Tagikistan", "TJST"}},
	    {"Asia/Hong_Kong", new String[] {"Ora di Hong Kong", "HKT",
					     "Ora estiva di Hong Kong", "HKST"}},
	    {"Asia/Irkutsk", new String[] {"Ora di Irkutsk", "IRKT",
					   "Ora estiva di Irkutsk", "IRKST"}},
        {"Asia/Jakarta", new String[] {"West Indonesia Time", "WIT",
                       "West Indonesia Summer Time", "WIST"}},
        {"Asia/Jayapura", new String[] {"East Indonesia Time", "EIT",
                        "East Indonesia Summer Time", "EIST"}},
	    {"Asia/Kabul", new String[] {"Ora Afghanistan", "AFT",
					 "Ora estiva Afghanistan", "AFST"}},
	    {"Asia/Kamchatka", new String[] {"Ora di Petropavlovsk-Kamchatski", "PETT",
					     "Ora estiva di Petropavlovsk-Kamchatski", "PETST"}},
	    {"Asia/Karachi", PKT},
	    {"Asia/Katmandu", new String[] {"Ora Nepal", "NPT",
					    "Ora estiva Nepal", "NPST"}},
	    {"Asia/Krasnoyarsk", new String[] {"Ora di Krasnojarsk", "KRAT",
					       "Ora estiva di Krasnojarsk", "KRAST"}},
	    {"Asia/Kuala_Lumpur", new String[] {"Ora Malaysia", "MYT",
						"Ora estiva Malaysia", "MYST"}},
	    {"Asia/Kuwait", ARAST},
	    {"Asia/Macao", CTT},
	    {"Asia/Macau", CTT},
	    {"Asia/Magadan", new String[] {"Ora di Magadan", "MAGT",
					   "Ora estiva di Magadan", "MAGST"}},
	    {"Asia/Makassar", CIT},
	    {"Asia/Manila", new String[] {"Ora Filippine", "PHT",
					  "Ora estiva Filippine", "PHST"}},
	    {"Asia/Muscat", GST},
	    {"Asia/Nicosia", EET},
	    {"Asia/Novosibirsk", new String[] {"Ora di Novosibirsk", "NOVT",
					       "Ora estiva di Novosibirsk", "NOVST"}},
	    {"Asia/Oral", new String[] {"Ora di Oral", "ORAT",
					"Ora estiva di Oral", "ORAST"}},
	    {"Asia/Phnom_Penh", ICT},
	    {"Asia/Pyongyang", KST},
	    {"Asia/Qatar", ARAST},
	    {"Asia/Qyzylorda", new String[] {"Ora di Qyzylorda", "QYZT",
					     "Ora estiva di Qyzylorda", "QYZST"}},
	    {"Asia/Rangoon", new String[] {"Ora Birmania/Myanmar", "MMT",
					   "Ora estiva Birmania/Myanmar", "MMST"}},
	    {"Asia/Riyadh", ARAST},
	    {"Asia/Saigon", ICT},
	    {"Asia/Seoul", KST},
	    {"Asia/Singapore", new String[] {"Ora Singapore", "SGT",
					     "Ora estiva Singapore", "SGST"}},
	    {"Asia/Taipei", CTT},
	    {"Asia/Tashkent", new String[] {"Ora Uzbekistan", "UZT",
					    "Ora estiva Uzbekistan", "UZST"}},
	    {"Asia/Tbilisi", new String[] {"Ora Georgia", "GET",
					   "Ora estiva Georgia", "GEST"}},
	    {"Asia/Tehran", IRT},
	    {"Asia/Thimbu", BTT},
	    {"Asia/Thimphu", BTT},
	    {"Asia/Ujung_Pandang", CIT},
	    {"Asia/Ulaanbaatar", ULAT},
	    {"Asia/Ulan_Bator", ULAT},
	    {"Asia/Vientiane", ICT},
	    {"Asia/Vladivostok", new String[] {"Ora di Vladivostok", "VLAT",
					       "Ora estiva di Vladivostok", "VLAST"}},
	    {"Asia/Yakutsk", new String[] {"Ora di Jakutsk", "YAKT",
					   "Ora estiva di Jakutsk", "YAKST"}},
	    {"Asia/Yekaterinburg", new String[] {"Ora di Ekaterinburg", "YEKT",
						 "Ora estiva di Ekaterinburg", "YEKST"}},
	    {"Asia/Yerevan", ARMT},
	    {"Atlantic/Azores", new String[] {"Ora Isole Azzorre", "AZOT",
					      "Ora estiva Isole Azzorre", "AZOST"}},
	    {"Atlantic/Bermuda", AST},
	    {"Atlantic/Canary", WET},
	    {"Atlantic/Cape_Verde", new String[] {"Ora Capo Verde", "CVT",
						  "Ora estiva Capo Verde", "CVST"}},
	    {"Atlantic/Faeroe", WET},
	    {"Atlantic/Jan_Mayen", EGT},
	    {"Atlantic/Reykjavik", GMT},
	    {"Atlantic/South_Georgia", new String[] {"Ora solare Georgia Australe", "GST",
						     "Ora legale Georgia Australe", "GDT"}},
	    {"Atlantic/St_Helena", GMT},
	    {"Atlantic/Stanley", new String[] {"Ora Isole Falkland", "FKT",
					       "Ora estiva Isole Falkland", "FKST"}},
	    {"Australia/Adelaide", new String[] {"Ora solare Australia Meridionale", "CST",
						 "Ora estiva Australia Meridionale", "CST"}},
	    {"Australia/Brisbane", new String[] {"Ora solare Australia orientale (Queensland)", "EST",
						 "Ora estiva Australia orientale (Queensland)", "EST"}},
	    {"Australia/Broken_Hill", new String[] {"Ora solare Australia Meridionale/Nuovo Galles del Sud", "CST",
						    "Ora estiva Australia Meridionale/Nuovo Galles del Sud", "CST"}},
	    {"Australia/Darwin", new String[] {"Ora solare Australia centrale (Territorio del Nord)", "CST",
					       "Ora estiva Australia centrale (Territorio del Nord)", "CST"}},
	    {"Australia/Hobart", new String[] {"Ora solare Australia orientale (Tasmania)", "EST",
					       "Ora estiva Australia orientale (Tasmania)", "EST"}},
	    {"Australia/Lord_Howe", new String[] {"Ora solare Isola Lord Howe", "LHST",
						  "Ora estiva Isola Lord Howe", "LHST"}},
	    {"Australia/Perth", WST_AUS},
	    {"Australia/Sydney", EST_NSW},
	    {"BET", BRT},
	    {"BST", BDT},
	    {"CAT", CAT},
	    {"EAT", EAT},
	    {"EET", EET},
	    {"Europe/Amsterdam", CET},
	    {"Europe/Andorra", CET},
	    {"Europe/Athens", EET},
	    {"Europe/Belgrade", CET},
	    {"Europe/Berlin", CET},
	    {"Europe/Brussels", CET},
	    {"Europe/Budapest", CET},
	    {"Europe/Chisinau", EET},
	    {"Europe/Copenhagen", CET},
	    {"Europe/Dublin", new String[] {"Ora media di Greenwich", "GMT",
					    "Ora estiva Irlanda", "IST"}},
	    {"Europe/Gibraltar", CET},
	    {"Europe/Helsinki", EET},
	    {"Europe/Istanbul", EET},
	    {"Europe/Kaliningrad", EET},
	    {"Europe/Kiev", EET},
	    {"Europe/Lisbon", WET},
	    {"Europe/London", new String[] {"Ora media di Greenwich", "GMT",
					    "Ora estiva Gran Bretagna", "BST"}},
	    {"Europe/Luxembourg", CET},
	    {"Europe/Madrid", CET},
	    {"Europe/Malta", CET},
	    {"Europe/Minsk", EET},
	    {"Europe/Monaco", CET},
	    {"Europe/Moscow", new String[] {"Ora solare di Mosca", "MSK",
					    "Ora legale di Mosca", "MSD"}},
	    {"Europe/Oslo", CET},
	    {"Europe/Prague", CET},
	    {"Europe/Riga", EET},
	    {"Europe/Rome", CET},
	    {"Europe/Samara", new String[] {"Ora di Samara", "SAMT",
					    "Ora estiva di Samara", "SAMST"}},
	    {"Europe/Simferopol", EET},
	    {"Europe/Sofia", EET},
	    {"Europe/Stockholm", CET},
	    {"Europe/Tallinn", EET},
	    {"Europe/Tirane", CET},
	    {"Europe/Vaduz", CET},
	    {"Europe/Vienna", CET},
	    {"Europe/Vilnius", EET},
	    {"Europe/Warsaw", CET},
	    {"Europe/Zurich", CET},
	    {"IST", IST},
	    {"Indian/Antananarivo", EAT},
	    {"Indian/Chagos", new String[] {"Ora Terr. Britannico dell'Oceano Indiano", "IOT",
					    "Ora estiva Terr. Britannico dell'Oceano Indiano", "IOST"}},
	    {"Indian/Christmas", new String[] {"Ora Isola Christmas", "CXT",
					       "Ora estiva Isola Christmas", "CXST"}},
	    {"Indian/Cocos", new String[] {"Ora Isole Cocos", "CCT",
					   "Ora estiva Isole Cocos", "CCST"}},
	    {"Indian/Comoro", EAT},
	    {"Indian/Kerguelen", new String[] {"Ora Terre Australi e Antartiche Francesi", "TFT",
					       "Ora estiva Terre Australi Antartiche Francesi", "TFST"}},
	    {"Indian/Mahe", new String[] {"Ora Seychelles", "SCT",
					  "Ora estiva Seychelles", "SCST"}},
	    {"Indian/Maldives", new String[] {"Ora Maldive", "MVT",
					      "Ora estiva Maldive", "MVST"}},
	    {"Indian/Mauritius", new String[] {"Ora Mauritius", "MUT",
					       "Ora estiva Mauritius", "MUST"}},
	    {"Indian/Mayotte", EAT},
	    {"Indian/Reunion", new String[] {"Ora Reunion", "RET",
					     "Ora estiva Reunion", "REST"}},
	    {"MET", IRT},
	    {"MIT", WST_SAMOA},
	    {"NET", ARMT},
	    {"NST", NZST},
	    {"PLT", PKT},
	    {"PRT", AST},
	    {"Pacific/Apia", WST_SAMOA},
	    {"Pacific/Auckland", NZST},
	    {"Pacific/Chatham", new String[] {"Ora solare Chatham", "CHAST",
					      "Ora legale Chatham", "CHADT"}},
	    {"Pacific/Easter", new String[] {"Ora Isola di Pasqua", "EAST",
					     "Ora estiva Isola di Pasqua", "EASST"}},
	    {"Pacific/Efate", new String[] {"Ora Vanuatu", "VUT",
					    "Ora estiva Vanuatu", "VUST"}},
	    {"Pacific/Enderbury", new String[] {"Ora Isola della Fenice", "PHOT",
						"Ora estiva Isola della Fenice", "PHOST"}},
	    {"Pacific/Fakaofo", new String[] {"Ora Tokelau", "TKT",
					      "Ora estiva Tokelau", "TKST"}},
	    {"Pacific/Fiji", new String[] {"Ora Figi", "FJT",
					   "Ora estiva Figi", "FJST"}},
	    {"Pacific/Funafuti", new String[] {"Ora Tuvalu", "TVT",
					       "Ora estiva Tuvalu", "TVST"}},
	    {"Pacific/Galapagos", new String[] {"Ora Galapagos", "GALT",
						"Ora estiva Galapagos", "GALST"}},
	    {"Pacific/Gambier", new String[] {"Ora Isole Gambier", "GAMT",
					      "Ora estiva Isole Gambier", "GAMST"}},
	    {"Pacific/Guadalcanal", SBT},
	    {"Pacific/Guam", ChST},
	    {"Pacific/Kiritimati", new String[] {"Ora Line Islands", "LINT",
						 "Ora estiva Line Islands", "LINST"}},
	    {"Pacific/Kosrae", new String[] {"Ora Kosrae", "KOST",
					     "Ora estiva Kosrae", "KOSST"}},
	    {"Pacific/Majuro", new String[] {"Ora Isole Marshall", "MHT",
					     "Ora estiva Isole Marshall", "MHST"}},
	    {"Pacific/Marquesas", new String[] {"Ora Isole Marchesi", "MART",
						"Ora estiva Isole Marchesi", "MARST"}},
	    {"Pacific/Nauru", new String[] {"Ora Nauru", "NRT",
					    "Ora estiva Nauru", "NRST"}},
	    {"Pacific/Niue", new String[] {"Ora Niue", "NUT",
					   "Ora estiva Niue", "NUST"}},
	    {"Pacific/Norfolk", new String[] {"Ora Norfolk", "NFT",
					      "Ora estiva Norfolk", "NFST"}},
	    {"Pacific/Noumea", new String[] {"Ora Nuova Caledonia", "NCT",
					     "Ora estiva Nuova Caledonia", "NCST"}},
	    {"Pacific/Pago_Pago", new String[] {"Ora solare Samoa", "SST",
						"Ora legale Samoa", "SDT"}},
	    {"Pacific/Palau", new String[] {"Ora Palau", "PWT",
					    "Ora estiva Palau", "PWST"}},
	    {"Pacific/Pitcairn", new String[] {"Ora solare Pitcairn", "PST",
					       "Ora legale Pitcairn", "PDT"}},
	    {"Pacific/Ponape", new String[] {"Ora Ponape", "PONT",
					     "Ora estiva Ponape", "PONST"}},
	    {"Pacific/Port_Moresby", new String[] {"Ora Papua Nuova Guinea", "PGT",
						   "Ora estiva Papua Nuova Guinea", "PGST"}},
	    {"Pacific/Rarotonga", new String[] {"Ora Isole Cook", "CKT",
						"Ora estiva Isole Cook", "CKST"}},
	    {"Pacific/Saipan", ChST},
	    {"Pacific/Tahiti", new String[] {"Ora Tahiti", "TAHT",
					     "Ora estiva Tahiti", "TAHST"}},
	    {"Pacific/Tarawa", new String[] {"Ora Isole Gilbert", "GILT",
					     "Ora estiva Isole Gilbert", "GILST"}},
	    {"Pacific/Tongatapu", new String[] {"Ora Tonga", "TOT",
						"Ora estiva Tonga", "TOST"}},
	    {"Pacific/Truk", new String[] {"Ora Truk", "TRUT",
					   "Ora estiva Truk", "TRUST"}},
	    {"Pacific/Wake", new String[] {"Ora Wake", "WAKT",
					   "Ora estiva Wake", "WAKST"}},
	    {"Pacific/Wallis", new String[] {"Ora Wallis e Futuna", "WFT",
					     "Ora estiva Wallis e Futuna", "WFST"}},
	    {"SST", SBT},
	    {"UTC", new String[] {"Tempo universale coordinato", "UTC",
			 	  "Tempo universale coordinato", "UTC"}},
	    {"VST", ICT},
	    {"WET", WET},

            {"localPatternChars", "GyMdkHmsSEDFwWahKzZ"},
        };
    }
}



