/*
 * @(#)DateFormatZoneData_zh_TW.java	1.33 03/05/01
 */

/*
 * Portions Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * (C) Copyright Taligent, Inc. 1996, 1997 - All Rights Reserved
 * (C) Copyright IBM Corp. 1996 - 1998 - All Rights Reserved
 *
 * The original version of this source code and documentation
 * is copyrighted and owned by Taligent, Inc., a wholly-owned
 * subsidiary of IBM. These materials are provided under terms
 * of a License Agreement between Taligent and Sun. This technology
 * is protected by multiple US and International patents.
 *
 * This notice and attribution to Taligent may not be removed.
 * Taligent is a registered trademark of Taligent, Inc.
 *
 */

package sun.text.resources;

/**
 * Supplement package private date-time formatting zone data for DateFormat.
 * DateFormatData used in DateFormat will be initialized by loading the data
 * from LocaleElements and DateFormatZoneData resources. The zone data are
 * represented with the following form:
 * {ID, new String[] {ID, long zone string, short zone string, long daylight 
 * string, short daylight string, representative city of zone}}, where ID is
 * NOT localized, but is used to look up the localized timezone data
 * internally. Localizers can localize any zone strings except
 * for the ID of the timezone.
 * Also, localizer should not touch "localPatternChars" entry.
 *
 * @see          ListResourceBundle
 * @see          Format
 * @see          DateFormatData
 * @see          LocaleElements
 * @see          SimpleDateFormat
 * @see          TimeZone
 * @version      1.29 12/04/01
 * @author       Chen-Lieh Huang
 */
//  Taiwan DateFormatZoneData
//
public final class DateFormatZoneData_zh_TW extends DateFormatZoneData
{
    /**
     * Overrides DateFormatZoneData
     */

    public Object[][] getContents() {
	String ACT[] = new String[] {"Acre \u6642\u9593", "ACT",
				     "Acre \u590f\u4ee4\u6642\u9593", "ACST"};
	String ADELAIDE[] = new String[] {"\u4e2d\u90e8\u6a19\u6e96\u6642\u9593 (\u6fb3\u5927\u5229\u4e9e\u5357\u5340)", "CST",
					  "\u4e2d\u90e8\u590f\u4ee4\u6642\u9593 (\u6fb3\u5927\u5229\u4e9e\u5357\u5340)", "CST"};
        String AGT[] = new String[] {"\u963f\u6839\u5ef7\u6642\u9593", "ART",
				     "\u963f\u6839\u5ef7\u590f\u4ee4\u6642\u9593", "ARST"};
	String AKST[] = new String[] {"\u963f\u62c9\u65af\u52a0\u6a19\u6e96\u6642\u9593", "AKST",
				      "\u963f\u62c9\u65af\u52a0\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "AKDT"};
	String AMT[] = new String[] {"\u4e9e\u99ac\u905c\u6cb3\u6a19\u6e96\u6642\u9593", "AMT",
				     "\u4e9e\u99ac\u905c\u590f\u4ee4\u6642\u9593", "AMST"};
	String ARAST[] = new String[] {"\u963f\u62c9\u4f2f\u6a19\u6e96\u6642\u9593", "AST",
				       "\u963f\u62c9\u4f2f\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "ADT"};
	String ARMT[] = new String[] {"\u4e9e\u7f8e\u5c3c\u4e9e\u6642\u9593", "AMT",
				      "\u4e9e\u7f8e\u5c3c\u4e9e\u590f\u4ee4\u6642\u9593", "AMST"};
	String AST[] = new String[] {"\u5927\u897f\u6d0b\u6a19\u6e96\u6642\u9593", "AST",
				     "\u5927\u897f\u6d0b\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "ADT"};
	String BDT[] = new String[] {"\u5b5f\u52a0\u62c9\u6642\u9593", "BDT",
				     "\u5b5f\u52a0\u62c9\u590f\u4ee4\u6642\u9593", "BDST"};
	String BRISBANE[] = new String[] {"\u6771\u90e8\u6a19\u6e96\u6642\u9593 (\u6606\u58eb\u862d)", "EST",
					  "\u6771\u90e8\u590f\u4ee4\u6642\u9593 (\u6606\u58eb\u862d)", "EST"};
	String BROKEN_HILL[] = new String[] {"\u4e2d\u90e8\u6a19\u6e96\u6642\u9593 (\u6fb3\u5927\u5229\u4e9e\u5357\u5340/\u65b0\u5357\u5a01\u723e\u65af)", "CST",
					     "\u4e2d\u90e8\u590f\u4ee4\u6642\u9593 (\u6fb3\u5927\u5229\u4e9e\u5357\u5340/\u65b0\u5357\u5a01\u723e\u65af)", "CST"};
	String BRT[] = new String[] {"\u5df4\u897f\u6642\u9593", "BRT",
				     "\u5df4\u897f\u590f\u4ee4\u6642\u9593", "BRST"};
	String BTT[] = new String[] {"\u4e0d\u4e39\u6642\u9593", "BTT",
				     "\u4e0d\u4e39\u590f\u4ee4\u6642\u9593", "BTST"};
	String CAT[] = new String[] {"\u4e2d\u975e\u6642\u9593", "CAT",
				     "\u4e2d\u975e\u590f\u4ee4\u6642\u9593", "CAST"};
	String CET[] = new String[] {"\u4e2d\u6b50\u6642\u9593", "CET",
				     "\u4e2d\u6b50\u590f\u4ee4\u6642\u9593", "CEST"};
	String CHAST[] = new String[] {"\u574e\u9054\u6a19\u6e96\u6642\u9593", "CHAST",
				       "\u574e\u9054\u65e5\u5149\u6642\u9593", "CHADT"};
	String CIT[] = new String[] {"\u4e2d\u5370\u5ea6\u5c3c\u897f\u4e9e\u6642\u9593", "CIT",
				     "\u4e2d\u5370\u5ea6\u5c3c\u897f\u4e9e\u590f\u4ee4\u6642\u9593", "CIST"};
	String CLT[] = new String[] {"\u667a\u5229\u6642\u9593", "CLT",
				     "\u667a\u5229\u590f\u4ee4\u6642\u9593", "CLST"};
	String CST[] = new String[] {"\u4e2d\u592e\u6a19\u6e96\u6642\u9593", "CST",
				     "\u4e2d\u592e\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "CDT"};
	String CTT[] = new String[] {"\u4e2d\u570b\u6a19\u6e96\u6642\u9593", "CST",
				     "\u4e2d\u570b\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "CDT"};
	String DARWIN[] = new String[] {"\u4e2d\u90e8\u6a19\u6e96\u6642\u9593 (\u5317\u90e8\u5404\u5730\u5340)", "CST",
					"\u4e2d\u90e8\u590f\u4ee4\u6642\u9593 (\u5317\u90e8\u5404\u5730\u5340)", "CST"};
	String DUBLIN[] = new String[] {"\u683c\u6797\u5a01\u6cbb\u5e73\u5747\u6642\u9593", "GMT",
					"\u611b\u723e\u862d\u590f\u4ee4\u6642\u9593", "IST"};
	String EAT[] = new String[] {"\u6771\u975e\u6642\u9593", "EAT",
				     "\u6771\u975e\u590f\u4ee4\u6642\u9593", "EAST"};
	String EASTER[] = new String[] {"\u5fa9\u6d3b\u5cf6\u6642\u9593", "EAST",
					"\u5fa9\u6d3b\u5cf6\u590f\u4ee4\u6642\u9593", "EASST"};
	String EET[] = new String[] {"\u6771\u6b50\u6642\u9593", "EET",
				     "\u6771\u6b50\u590f\u4ee4\u6642\u9593", "EEST"};
	String EGT[] = new String[] {"\u6771\u683c\u6797\u5cf6\u6642\u9593", "EGT",
				     "\u6771\u683c\u6797\u5cf6\u590f\u4ee4\u6642\u9593", "EGST"};
	String EST[] = new String[] {"\u6771\u65b9\u6a19\u6e96\u6642\u9593", "EST",
				     "\u6771\u65b9\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "EDT"};
	String EST_NSW[] = new String[] {"\u6771\u65b9\u6a19\u6e96\u6642\u9593 (\u65b0\u5357\u5a01\u723e\u65af)", "EST",
					 "\u6771\u65b9\u590f\u4ee4\u6642\u9593 (\u65b0\u5357\u5a01\u723e\u65af)", "EST"};
	String GAMBIER[] =  new String[] {"\u7518\u6bd4\u723e\u6642\u9593", "GAMT",
					  "\u7518\u6bd4\u723e\u590f\u4ee4\u6642\u9593", "GAMST"};
	String GMT[] = new String[] {"\u683c\u6797\u5a01\u6cbb\u6642\u9593", "GMT",
				   "\u683c\u6797\u5a01\u6cbb\u6642\u9593", "GMT"};
	String GMTBST[] = new String[] {"\u683c\u6797\u5a01\u6cbb\u5e73\u5747\u6642\u9593", "GMT",
					"\u82f1\u570b\u590f\u4ee4\u6642\u9593", "BST"};
	String GST[] = new String[] {"\u6ce2\u65af\u7063\u6a19\u6e96\u6642\u9593", "GST",
				     "\u6ce2\u65af\u7063\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "GDT"};
	String HAST[] = new String[] {"\u590f\u5a01\u5937-\u963f\u7559\u7533\u7fa4\u5cf6\u6a19\u6e96\u6642\u9593", "HAST",
				      "\u590f\u5a01\u5937-\u963f\u7559\u7533\u7fa4\u5cf6\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "HADT"};
	String HKT[] =  new String[] {"\u9999\u6e2f\u6642\u9593", "HKT",
				      "\u9999\u6e2f\u590f\u4ee4\u6642\u9593", "HKST"};
	String HST[] = new String[] {"\u590f\u5a01\u5937\u6a19\u6e96\u6642\u9593", "HST",
				     "\u590f\u5a01\u5937\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "HDT"};
	String ICT[] = new String[] {"\u5370\u5ea6\u652f\u90a3\u6642\u9593", "ICT",
				     "\u5370\u5ea6\u652f\u90a3\u590f\u4ee4\u6642\u9593", "ICST"};
	String IRT[] = new String[] {"\u4f0a\u6717\u6a19\u6e96\u6642\u9593", "IRT",
				     "\u4f0a\u6717\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "IRST"};
	String ISRAEL[] = new String[] {"\u4ee5\u8272\u5217\u6a19\u6e96\u6642\u9593", "IST",
					"\u4ee5\u8272\u5217\u65e5\u5149\u6642\u9593", "IDT"};
	String IST[] = new String[] {"\u5370\u5ea6\u6a19\u6e96\u6642\u9593", "IST",
				     "\u5370\u5ea6\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "IDT"};
	String JST[] = new String[] {"\u65e5\u672c\u6a19\u6e96\u6642\u9593", "JST",
				     "\u65e5\u672c\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "JDT"};
	String KST[] = new String[] {"\u97d3\u570b\u6a19\u6e96\u6642\u9593", "KST",
				     "\u97d3\u570b\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "KDT"};
	String LORD_HOWE[] = new String[] {"Load Howe \u6a19\u6e96\u6642\u9593", "LHST",
					   "Load Howe \u590f\u4ee4\u6642\u9593", "LHST"};
	String MHT[] = new String[] {"\u99ac\u7d39\u723e\u7fa4\u5cf6\u6642\u9593", "MHT",
				     "\u99ac\u7d39\u723e\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "MHST"};
	String MSK[] = new String[] {"\u83ab\u65af\u79d1\u6a19\u6e96\u6642\u9593", "MSK",
				     "\u83ab\u65af\u79d1\u65e5\u5149\u6642\u9593", "MSD"};
	String MST[] = new String[] {"Mountain \u6a19\u6e96\u6642\u9593", "MST",
				     "Mountain \u65e5\u5149\u7bc0\u7d04\u6642\u9593", "MDT"};
	String MYT[] = new String[] {"\u99ac\u4f86\u897f\u4e9e\u6642\u9593", "MYT",
				     "\u99ac\u4f86\u897f\u4e9e\u590f\u4ee4\u6642\u9593", "MYST"};
	String NORONHA[] = new String[] {"\u8cbb\u723e\u5357\u591a-\u8fea\u8afe\u7f85\u5c3c\u4e9e\u6642\u9593", "FNT",
					 "\u8cbb\u723e\u5357\u591a-\u8fea\u8afe\u7f85\u5c3c\u4e9e\u590f\u4ee4\u6642\u9593", "FNST"};
	String NST[] = new String[] {"\u7d10\u82ac\u862d\u6a19\u6e96\u6642\u9593", "NST",
				     "\u7d10\u82ac\u862d\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "NDT"};
	String NZST[] = new String[] {"\u7d10\u897f\u862d\u6a19\u6e96\u6642\u9593", "NZST",
				      "\u7d10\u897f\u862d\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "NZDT"};
        String PITCAIRN[] = new String[] {"\u76ae\u7279\u5eb7\u6a19\u6e96\u6642\u9593", "PST",
				        "\u76ae\u7279\u5eb7\u65e5\u5149\u6642\u9593", "PDT"};
	String PKT[] = new String[] {"\u5df4\u57fa\u65af\u5766\u6642\u9593", "PKT",
				     "\u5df4\u57fa\u65af\u5766\u590f\u4ee4\u6642\u9593", "PKST"};
	String PST[] = new String[] {"\u592a\u5e73\u6d0b\u6a19\u6e96\u6642\u9593", "PST",
				     "\u592a\u5e73\u6d0b\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "PDT"};
	String SAST[] = new String[] {"\u5357\u975e\u6a19\u6e96\u6642\u9593", "SAST",
				      "\u5357\u975e\u590f\u4ee4\u6642\u9593", "SAST"};
	String SBT[] = new String[] {"\u6240\u7f85\u9580\u7fa4\u5cf6\u6642\u9593", "SBT",
				     "\u6240\u7f85\u9580\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "SBST"};
	String SGT[] = new String[] {"\u65b0\u52a0\u5761\u6642\u9593", "SGT",
				     "\u65b0\u52a0\u5761\u590f\u4ee4\u6642\u9593", "SGST"};
	String TASMANIA[] = new String[] {"\u6771\u90e8\u6a19\u6e96\u6642\u9593 (\u5854\u65af\u6885\u5c3c\u4e9e\u5cf6)", "EST",
					  "\u6771\u90e8\u590f\u4ee4\u6642\u9593 (\u5854\u65af\u6885\u5c3c\u4e9e\u5cf6)", "EST"};
	String TMT[] = new String[] {"\u571f\u5eab\u66fc\u6642\u9593", "TMT",
				     "\u571f\u5eab\u66fc\u590f\u4ee4\u6642\u9593", "TMST"};
	String ULAT[]= new String[] {"\u5eab\u502b\u6642\u9593", "ULAT",
				     "\u5eab\u502b\u590f\u4ee4\u6642\u9593", "ULAST"};
	String WAT[] = new String[] {"\u897f\u975e\u6642\u9593", "WAT",
				     "\u897f\u975e\u590f\u4ee4\u6642\u9593", "WAST"};
	String WET[] = new String[] {"\u897f\u6b50\u6642\u9593", "WET",
				     "\u897f\u6b50\u590f\u4ee4\u6642\u9593", "WEST"};
	String WIT[] = new String[] {"\u897f\u5370\u5c3c\u6642\u9593", "WIT",
				     "\u897f\u5370\u5c3c\u590f\u4ee4\u6642\u9593", "WIST"};
	String WST_AUS[] = new String[] {"\u897f\u65b9\u6a19\u6e96\u6642\u9593 (\u6fb3\u5927\u5229\u4e9e)", "WST",
					 "\u897f\u65b9\u590f\u4ee4\u6642\u9593 (\u6fb3\u5927\u5229\u4e9e)", "WST"};
	String SAMOA[] = new String[] {"\u85a9\u6469\u4e9e\u6a19\u6e96\u6642\u9593", "SST",
				       "\u85a9\u6469\u4e9e\u65e5\u5149\u6642\u9593", "SDT"};
	String WST_SAMOA[] = new String[] {"\u897f\u85a9\u6469\u4e9e\u6642\u9593", "WST",
					   "\u897f\u85a9\u6469\u4e9e\u590f\u4ee4\u6642\u9593", "WSST"};
	String ChST[] = new String[] {"\u67e5\u83ab\u6d1b\u6a19\u6e96\u6642\u9593", "ChST",
				     "\u67e5\u83ab\u6d1b\u65e5\u5149\u6642\u9593", "ChDT"};
	String VICTORIA[] = new String[] {"\u6771\u90e8\u6a19\u6e96\u6642\u9593 (\u7dad\u591a\u5229\u4e9e\u90a6)", "EST",
					  "\u6771\u90e8\u590f\u4ee4\u6642\u9593 (\u7dad\u591a\u5229\u4e9e\u90a6)", "EST"};
	String UTC[] = new String[] {"\u5354\u8abf\u4e16\u754c\u6642\u9593", "UTC",
			 	     "\u5354\u8abf\u4e16\u754c\u6642\u9593", "UTC"};

	return new Object[][] {
	    {"PST", PST},
	    {"America/Los_Angeles", PST},
	    {"MST", MST},
	    {"America/Denver", MST},
	    {"PNT", MST},
	    {"America/Phoenix", MST},
	    {"CST", CST},
	    {"America/Chicago", CST},
	    {"EST", EST},
	    {"America/New_York", EST},
	    {"IET", EST},
	    {"America/Indianapolis", EST},
	    {"HST", HST},
	    {"Pacific/Honolulu", HST},
	    {"AST", AKST},
	    {"America/Anchorage", AKST},
	    {"America/Halifax", AST},
	    {"CNT", NST},
	    {"America/St_Johns", NST},
	    {"ECT", CET},
	    {"Europe/Paris", CET},
	    {"GMT", GMT},
	    {"Africa/Casablanca", WET},
	    {"Asia/Jerusalem", new String[] {"\u4ee5\u8272\u5217\u6a19\u6e96\u6642\u9593", "IST",
					     "\u4ee5\u8272\u5217\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "IDT"}},
	    {"JST", JST},
	    {"Asia/Tokyo", JST},
	    {"Europe/Bucharest", EET},
	    {"CTT", CTT},
	    {"Asia/Shanghai", CTT},
	    /* Don't change the order of the above zones
	     * to keep compatibility with the previous version.
	     */

	    {"ACT", new String[] {"\u4e2d\u592e\u6a19\u6e96\u6642\u9593 (\u5317\u7f8e\u6d32)", "CST",
				  "\u4e2d\u592e\u65e5\u5149\u7bc0\u7d04\u6642\u9593 (\u5317\u7f8e\u6d32)", "CDT"}},
	    {"AET", EST_NSW},
	    {"AGT", AGT},
	    {"ART", EET},
	    {"Africa/Abidjan", GMT},
	    {"Africa/Accra", GMT},
	    {"Africa/Addis_Ababa", EAT},
	    {"Africa/Algiers", CET},
	    {"Africa/Asmera", EAT},
	    {"Africa/Bamako", GMT},
	    {"Africa/Bangui", WAT},
	    {"Africa/Banjul", GMT},
	    {"Africa/Bissau", GMT},
	    {"Africa/Blantyre", CAT},
	    {"Africa/Brazzaville", WAT},
	    {"Africa/Bujumbura", CAT},
	    {"Africa/Cairo", EET},
	    {"Africa/Ceuta", CET},
	    {"Africa/Conakry", GMT},
	    {"Africa/Dakar", GMT},
	    {"Africa/Dar_es_Salaam", EAT},
	    {"Africa/Djibouti", EAT},
	    {"Africa/Douala", WAT},
	    {"Africa/El_Aaiun", WET},
	    {"Africa/Freetown", GMT},
	    {"Africa/Gaborone", CAT},
	    {"Africa/Harare", CAT},
	    {"Africa/Johannesburg", SAST},
	    {"Africa/Kampala", EAT},
	    {"Africa/Khartoum", EAT},
	    {"Africa/Kigali", CAT},
	    {"Africa/Kinshasa", WAT},
	    {"Africa/Lagos", WAT},
	    {"Africa/Libreville", WAT},
	    {"Africa/Lome", GMT},
	    {"Africa/Luanda", WAT},
	    {"Africa/Lubumbashi", CAT},
	    {"Africa/Lusaka", CAT},
	    {"Africa/Malabo", WAT},
	    {"Africa/Maputo", CAT},
	    {"Africa/Maseru", SAST},
	    {"Africa/Mbabane", SAST},
	    {"Africa/Mogadishu", EAT},
	    {"Africa/Monrovia", GMT},
	    {"Africa/Nairobi", EAT},
	    {"Africa/Ndjamena", WAT},
	    {"Africa/Niamey", WAT},
	    {"Africa/Nouakchott", GMT},
	    {"Africa/Ouagadougou", GMT},
	    {"Africa/Porto-Novo", WAT},
	    {"Africa/Sao_Tome", GMT},
	    {"Africa/Timbuktu", GMT},
	    {"Africa/Tripoli", EET},
	    {"Africa/Tunis", CET},
	    {"Africa/Windhoek", WAT},
	    {"America/Adak", HAST},
	    {"America/Anguilla", AST},
	    {"America/Antigua", AST},
	    {"America/Araguaina", BRT},
	    {"America/Aruba", AST},
	    {"America/Asuncion", new String[] {"\u5df4\u62c9\u572d\u6642\u9593", "PYT",
					       "\u5df4\u62c9\u572d\u590f\u4ee4\u6642\u9593", "PYST"}},
	    {"America/Atka", HAST},
	    {"America/Barbados", AST},
	    {"America/Belem", BRT},
	    {"America/Belize", CST},
	    {"America/Boa_Vista", AMT},
	    {"America/Bogota", new String[] {"\u54e5\u502b\u6bd4\u4e9e\u6642\u9593", "COT",
					     "\u54e5\u502b\u6bd4\u4e9e\u590f\u4ee4\u6642\u9593", "COST"}},
	    {"America/Boise", MST},
	    {"America/Buenos_Aires", AGT},
	    {"America/Cambridge_Bay", MST},
	    {"America/Cancun", CST},
	    {"America/Caracas", new String[] {"\u59d4\u5167\u745e\u62c9\u6642\u9593", "VET",
					      "\u59d4\u5167\u745e\u62c9\u590f\u4ee4\u6642\u9593", "VEST"}},
	    {"America/Catamarca", AGT},
	    {"America/Cayenne", new String[] {"\u6cd5\u5c6c\u572d\u4e9e\u90a3\u6642\u9593", "GFT",
					      "\u6cd5\u5c6c\u572d\u4e9e\u90a3\u590f\u4ee4\u6642\u9593", "GFST"}},
	    {"America/Cayman", EST},
	    {"America/Chihuahua", MST},
	    {"America/Cordoba", AGT},
	    {"America/Costa_Rica", CST},
	    {"America/Cuiaba", AMT},
	    {"America/Curacao", AST},
	    {"America/Danmarkshavn", GMT},
	    {"America/Dawson", PST},
	    {"America/Dawson_Creek", MST},
	    {"America/Detroit", EST},
	    {"America/Dominica", AST},
	    {"America/Edmonton", MST},
	    {"America/Eirunepe", ACT},
	    {"America/El_Salvador", CST},
	    {"America/Ensenada", PST},
	    {"America/Fort_Wayne", EST},
	    {"America/Fortaleza", BRT},
	    {"America/Glace_Bay", AST},
	    {"America/Godthab", new String[] {"\u897f\u683c\u6797\u862d\u5cf6\u6642\u9593", "WGT",
					      "\u897f\u683c\u6797\u862d\u5cf6\u590f\u4ee4\u6642\u9593", "WGST"}},
	    {"America/Goose_Bay", AST},
	    {"America/Grand_Turk", EST},
	    {"America/Grenada", AST},
	    {"America/Guadeloupe", AST},
	    {"America/Guatemala", CST},
	    {"America/Guayaquil", new String[] {"\u5384\u74dc\u591a\u723e\u6642\u9593", "ECT",
						"\u5384\u74dc\u591a\u723e\u590f\u4ee4\u6642\u9593", "ECST"}},
	    {"America/Guyana", new String[] {"\u84cb\u4e9e\u90a3\u6642\u9593", "GYT",
					     "\u84cb\u4e9e\u90a3\u590f\u4ee4\u6642\u9593", "GYST"}},
	    {"America/Havana", CST},
	    {"America/Hermosillo", MST},
	    {"America/Indiana/Indianapolis", EST},
	    {"America/Indiana/Knox", EST},
	    {"America/Indiana/Marengo", EST},
	    {"America/Indiana/Vevay", EST},
	    {"America/Inuvik", MST},
	    {"America/Iqaluit", EST},
	    {"America/Jamaica", EST},
	    {"America/Jujuy", AGT},
	    {"America/Juneau", AKST},
	    {"America/Kentucky/Louisville", EST},
	    {"America/Kentucky/Monticello", EST},
	    {"America/Knox_IN", EST},
	    {"America/La_Paz", new String[] {"\u73bb\u5229\u7dad\u4e9e\u6642\u9593", "BOT",
					     "\u73bb\u5229\u7dad\u4e9e\u590f\u4ee4\u6642\u9593", "BOST"}},
	    {"America/Lima", new String[] {"\u7955\u9b6f\u6642\u9593", "PET",
					   "\u7955\u9b6f\u590f\u4ee4\u6642\u9593", "PEST"}},
	    {"America/Louisville", EST},
	    {"America/Maceio", BRT},
	    {"America/Managua", CST},
	    {"America/Manaus", AMT},
	    {"America/Martinique", AST},
	    {"America/Mazatlan", MST},
	    {"America/Mendoza", AGT},
	    {"America/Menominee", CST},
	    {"America/Merida", CST},
	    {"America/Mexico_City", CST},
	    {"America/Miquelon", new String[] {"\u76ae\u57c3\u723e\u5cf6\u53ca\u5bc6\u514b\u9686\u5cf6\u6a19\u6e96\u6642\u9593", "PMST",
					       "\u76ae\u57c3\u723e\u5cf6\u53ca\u5bc6\u514b\u9686\u5cf6\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "PMDT"}},
	    {"America/Montevideo", new String[] {"\u70cf\u62c9\u572d\u6642\u9593", "UYT",
						 "\u70cf\u62c9\u572d\u590f\u4ee4\u6642\u9593", "UYST"}},
	    {"America/Monterrey", CST},
	    {"America/Montreal", EST},
	    {"America/Montserrat", AST},
	    {"America/Nassau", EST},
	    {"America/Nipigon", EST},
	    {"America/Nome", AKST},
	    {"America/Noronha", NORONHA},
	    {"America/North_Dakota/Center", CST},
	    {"America/Panama", EST},
	    {"America/Pangnirtung", EST},
	    {"America/Paramaribo", new String[] {"\u8607\u5229\u5357\u6642\u9593", "SRT",
						 "\u8607\u5229\u5357\u590f\u4ee4\u6642\u9593", "SRST"}},
	    {"America/Port-au-Prince", EST},
	    {"America/Port_of_Spain", AST},
	    {"America/Porto_Acre", ACT},
	    {"America/Porto_Velho", AMT},
	    {"America/Puerto_Rico", AST},
	    {"America/Rainy_River", CST},
	    {"America/Rankin_Inlet", EST},
	    {"America/Recife", BRT},
	    {"America/Regina", CST},
	    {"America/Rio_Branco", ACT},
	    {"America/Rosario", AGT},
	    {"America/Santiago", CLT},
	    {"America/Santo_Domingo", AST},
	    {"America/Sao_Paulo", BRT},
	    {"America/Scoresbysund", EGT},
	    {"America/Shiprock", MST},
	    {"America/St_Kitts", AST},
	    {"America/St_Lucia", AST},
	    {"America/St_Thomas", AST},
	    {"America/St_Vincent", AST},
	    {"America/Swift_Current", CST},
	    {"America/Tegucigalpa", CST},
	    {"America/Thule", AST},
	    {"America/Thunder_Bay", EST},
	    {"America/Tijuana", PST},
	    {"America/Tortola", AST},
	    {"America/Vancouver", PST},
	    {"America/Virgin", AST},
	    {"America/Whitehorse", PST},
	    {"America/Winnipeg", CST},
	    {"America/Yakutat", AKST},
	    {"America/Yellowknife", MST},
	    {"Antarctica/Casey", WST_AUS},
	    {"Antarctica/Davis", new String[] {"\u81fa\u7dad\u65af\u6642\u9593", "DAVT",
					       "\u81fa\u7dad\u65af\u6642\u9593", "DAVT"}},
	    {"Antarctica/DumontDUrville", new String[] {"Dumont-d'Urville Time", "DDUT",
							"Dumont-d'Urville Summer Time", "DDUST"}},
	    {"Antarctica/Mawson", new String[] {"\u83ab\u68ee\u6642\u9593", "MAWT",
						"\u83ab\u68ee\u590f\u4ee4\u6642\u9593", "MAWST"}},
	    {"Antarctica/McMurdo", NZST},
	    {"Antarctica/Palmer", CLT},
	    {"Antarctica/Rothera", new String[] {"\u7f85\u897f\u62c9\u6642\u9593", "ROTT",
                                                 "\u7f85\u897f\u62c9\u590f\u4ee4\u6642\u9593", "ROTST"}},
	    {"Antarctica/South_Pole", NZST},
	    {"Antarctica/Syowa", new String[] {"\u5915\u6b50\u74e6 (Syowa) \u6642\u9593", "SYOT",
					       "\u5915\u6b50\u74e6 (Syowa) \u6642\u9593", "SYOT"}},
	    {"Antarctica/Vostok", new String[] {"\u4f5b\u65af\u6258 (Vostok) \u6642\u9593", "VOST",
						"\u4f5b\u65af\u6258 (Vostok) \u6642\u9593", "VOST"}},
	    {"Arctic/Longyearbyen", CET},
	    {"Asia/Aden", ARAST},
	    {"Asia/Almaty", new String[] {"Alma-Ata \u6642\u9593", "ALMT",
					  "Alma-Ata \u590f\u4ee4\u6642\u9593", "ALMST"}},
	    {"Asia/Amman", EET},
	    {"Asia/Anadyr", new String[] {"\u963f\u90a3\u5e95\u6cb3\u6642\u9593", "ANAT",
					  "\u963f\u90a3\u5e95\u6cb3\u590f\u4ee4\u6642\u9593", "ANAST"}},
	    {"Asia/Aqtau", new String[] {"Aqtau \u6642\u9593", "AQTT",
					 "Aqtau \u590f\u4ee4\u6642\u9593", "AQTST"}},
	    {"Asia/Aqtobe", new String[] {"Aqtobe \u6642\u9593", "AQTT",
					  "Aqtobe \u590f\u4ee4\u6642\u9593", "AQTST"}},
	    {"Asia/Ashgabat", TMT},
	    {"Asia/Ashkhabad", TMT},
	    {"Asia/Baghdad", ARAST},
	    {"Asia/Bahrain", ARAST},
	    {"Asia/Baku", new String[] {"\u4e9e\u585e\u62dc\u7136\u6642\u9593", "AZT",
					"\u4e9e\u585e\u62dc\u7136\u590f\u4ee4\u6642\u9593", "AZST"}},
	    {"Asia/Bangkok", ICT},
	    {"Asia/Beirut", EET},
	    {"Asia/Bishkek", new String[] {"Kirgizstan \u6642\u9593", "KGT",
					   "Kirgizstan \u590f\u4ee4\u6642\u9593", "KGST"}},
	    {"Asia/Brunei", new String[] {"\u6c76\u840a\u6642\u9593", "BNT",
					  "\u6c76\u840a\u590f\u4ee4\u6642\u9593", "BNST"}},
	    {"Asia/Calcutta", IST},
	    {"Asia/Choibalsan", new String[] {"\u5de7\u5df4\u5c71 (Choibalsan) \u6642\u9593", "CHOT",
					      "\u5de7\u5df4\u5c71 (Choibalsan) \u590f\u4ee4\u6642\u9593", "CHOST"}},
	    {"Asia/Chongqing", CTT},
	    {"Asia/Chungking", CTT},
	    {"Asia/Colombo", new String[] {"\u65af\u91cc\u862d\u5361\u6642\u9593", "LKT",
					   "\u65af\u91cc\u862d\u5361\u590f\u4ee4\u6642\u9593", "LKST"}},
	    {"Asia/Dacca", BDT},
	    {"Asia/Dhaka", BDT},
	    {"Asia/Dili", new String[] {"\u6771\u5e1d\u6c76\u6642\u9593", "TPT",
					"\u6771\u5e1d\u6c76\u590f\u4ee4\u6642\u9593", "TPST"}},
	    {"Asia/Damascus", EET},
	    {"Asia/Dubai", GST},
	    {"Asia/Dushanbe", new String[] {"Tajikistan \u6642\u9593", "TJT",
					    "Tajikistan \u590f\u4ee4\u6642\u9593", "TJST"}},
	    {"Asia/Gaza", EET},
	    {"Asia/Harbin", CTT},
	    {"Asia/Hong_Kong", HKT},
	    {"Asia/Hovd", new String[] {"\u4faf\u5fb7 (Hovd) \u6642\u9593", "HOVT",
					"\u4faf\u5fb7 (Hovd) \u590f\u4ee4\u6642\u9593", "HOVST"}},
	    {"Asia/Irkutsk", new String[] {"Irkutsk \u6642\u9593", "IRKT",
					   "Irkutsk \u590f\u4ee4\u6642\u9593", "IRKST"}},
	    {"Asia/Istanbul", EET},
	    {"Asia/Jakarta", WIT},
	    {"Asia/Jayapura", new String[] {"\u6771\u5370\u5ea6\u5c3c\u897f\u4e9e\u6642\u9593", "EIT",
					    "\u6771\u5370\u5ea6\u5c3c\u897f\u4e9e\u590f\u65e5\u6642\u9593", "EIST"}},
	    {"Asia/Kabul", new String[] {"\u963f\u5bcc\u6c57\u6642\u9593", "AFT",
					 "\u963f\u5bcc\u6c57\u590f\u4ee4\u6642\u9593", "AFST"}},
	    {"Asia/Kamchatka", new String[] {"Petropavlovsk-Kamchatski \u6642\u9593", "PETT",
					     "Petropavlovsk-Kamchatski \u590f\u4ee4\u6642\u9593", "PETST"}},
	    {"Asia/Karachi", PKT},
	    {"Asia/Kashgar", CTT},
	    {"Asia/Katmandu", new String[] {"\u5c3c\u6cca\u723e\u6642\u9593", "NPT",
					    "\u5c3c\u6cca\u723e\u590f\u4ee4\u6642\u9593", "NPST"}},
	    {"Asia/Krasnoyarsk", new String[] {"\u514b\u62c9\u65af\u8afe\u4e9e\u723e\u65af\u514b\u6642\u9593", "KRAT",
					       "\u514b\u62c9\u65af\u8afe\u4e9e\u723e\u65af\u514b\u590f\u4ee4\u6642\u9593", "KRAST"}},
	    {"Asia/Kuala_Lumpur", MYT},
	    {"Asia/Kuching", MYT},
	    {"Asia/Kuwait", ARAST},
	    {"Asia/Macao", CTT},
	    {"Asia/Macau", CTT},
	    {"Asia/Magadan", new String[] {"Magadan \u6642\u9593", "MAGT",
					   "Magadan \u590f\u4ee4\u6642\u9593", "MAGST"}},
	    {"Asia/Makassar", CIT},
	    {"Asia/Manila", new String[] {"\u83f2\u5f8b\u8cd3\u6642\u9593", "PHT",
					  "\u83f2\u5f8b\u8cd3\u590f\u4ee4\u6642\u9593", "PHST"}},
	    {"Asia/Muscat", GST},
	    {"Asia/Nicosia", EET},
	    {"Asia/Novosibirsk", new String[] {"Novosibirsk \u6642\u9593", "NOVT",
					       "Novosibirsk \u590f\u4ee4\u6642\u9593", "NOVST"}},
	    {"Asia/Oral", new String[] {"\u6b50\u4f5b\u6642\u9593", "ORAT",
					"\u6b50\u4f5b\u590f\u4ee4\u6642\u9593", "ORAST"}},
	    {"Asia/Omsk", new String[] {"\u6b50\u59c6\u65af\u514b (Omsk) \u6642\u9593", "OMST",
					"\u6b50\u59c6\u65af\u514b (Omsk) \u590f\u4ee4\u6642\u9593", "OMSST"}},
	    {"Asia/Phnom_Penh", ICT},
	    {"Asia/Pontianak", WIT},
	    {"Asia/Pyongyang", KST},
	    {"Asia/Qatar", ARAST},
	    {"Asia/Qyzylorda", new String[] {"Qyzylorda \u6642\u9593", "QYZT",
					     "Qyzylorda \u590f\u4ee4\u6642\u9593", "QYZST"}},
	    {"Asia/Rangoon", new String[] {"\u7dec\u7538\u6642\u9593", "MMT",
					   "\u7dec\u7538\u590f\u4ee4\u6642\u9593", "MMST"}},
	    {"Asia/Riyadh", ARAST},
	    {"Asia/Saigon", ICT},
	    {"Asia/Sakhalin", new String[] {"\u5eab\u9801\u5cf6\u6642\u9593", "SAKT",
					    "\u5eab\u9801\u5cf6\u590f\u4ee4\u6642\u9593", "SAKST"}},
	    {"Asia/Samarkand", TMT},
	    {"Asia/Seoul", KST},
	    {"Asia/Singapore", SGT},
	    {"Asia/Taipei", CTT},
	    {"Asia/Tel_Aviv", ISRAEL},
	    {"Asia/Tashkent", new String[] {"Uzbekistan \u6642\u9593", "UZT",
					    "Uzbekistan \u590f\u4ee4\u6642\u9593", "UZST"}},
	    {"Asia/Tbilisi", new String[] {"\u55ac\u6cbb\u4e9e\u6642\u9593", "GET",
					   "\u55ac\u6cbb\u4e9e\u590f\u4ee4\u6642\u9593", "GEST"}},
	    {"Asia/Tehran", IRT},
	    {"Asia/Thimbu", BTT},
	    {"Asia/Thimphu", BTT},
	    {"Asia/Ujung_Pandang", CIT},
	    {"Asia/Ulaanbaatar", ULAT},
	    {"Asia/Ulan_Bator", ULAT},
	    {"Asia/Urumqi", CTT},
	    {"Asia/Vientiane", ICT},
	    {"Asia/Vladivostok", new String[] {"\u6d77\u53c3\u5d34\u6642\u9593", "VLAT",
					       "\u6d77\u53c3\u5d34\u590f\u4ee4\u6642\u9593", "VLAST"}},
	    {"Asia/Yakutsk", new String[] {"\u4e9e\u5eab\u6b21\u514b\u6642\u9593", "YAKT",
					   "\u4e9e\u5eab\u6b21\u514b\u590f\u4ee4\u6642\u9593", "YAKST"}},
	    {"Asia/Yekaterinburg", new String[] {"Yekaterinburg \u6642\u9593", "YEKT",
						 "Yekaterinburg \u590f\u4ee4\u6642\u9593", "YEKST"}},
	    {"Asia/Yerevan", ARMT},
	    {"Atlantic/Azores", new String[] {"\u4e9e\u901f\u723e\u7fa4\u5cf6\u6642\u9593", "AZOT",
					      "\u4e9e\u901f\u723e\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "AZOST"}},
	    {"Atlantic/Bermuda", AST},
	    {"Atlantic/Canary", WET},
	    {"Atlantic/Cape_Verde", new String[] {"\u4f5b\u5fb7\u89d2\u6642\u9593", "CVT",
						  "\u4f5b\u5fb7\u89d2\u590f\u4ee4\u6642\u9593", "CVST"}},
	    {"Atlantic/Faeroe", WET},
	    {"Atlantic/Jan_Mayen", EGT},
	    {"Atlantic/Madeira", WET},
	    {"Atlantic/Reykjavik", GMT},
	    {"Atlantic/South_Georgia", new String[] {"\u5357\u55ac\u6cbb\u4e9e\u6a19\u6e96\u6642\u9593", "GST",
						     "\u5357\u55ac\u6cbb\u4e9e\u65e5\u5149\u7bc0\u7d04\u6642\u9593", "GDT"}},
	    {"Atlantic/St_Helena", GMT},
	    {"Atlantic/Stanley", new String[] {"\u798f\u514b\u862d\u7fa4\u5cf6\u6642\u9593", "FKT",
					       "\u798f\u514b\u862d\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "FKST"}},
	    {"Australia/ACT", EST_NSW},
	    {"Australia/Adelaide", ADELAIDE},
	    {"Australia/Brisbane", BRISBANE},
	    {"Australia/Broken_Hill", BROKEN_HILL},
	    {"Australia/Canberra", EST_NSW},
	    {"Australia/Darwin", DARWIN},
	    {"Australia/Hobart", TASMANIA},
	    {"Australia/LHI", LORD_HOWE},
	    {"Australia/Lindeman", BRISBANE},
	    {"Australia/Lord_Howe", LORD_HOWE},
	    {"Australia/Melbourne", VICTORIA},
	    {"Australia/North", DARWIN},
	    {"Australia/NSW", EST_NSW},
	    {"Australia/Perth", WST_AUS},
	    {"Australia/Queensland", BRISBANE},
	    {"Australia/South", ADELAIDE},
	    {"Australia/Sydney", EST_NSW},
	    {"Australia/Tasmania", TASMANIA},
	    {"Australia/Victoria", VICTORIA},
	    {"Australia/West", WST_AUS},
	    {"Australia/Yancowinna", BROKEN_HILL},
	    {"BET", BRT},
	    {"BST", BDT},
	    {"Brazil/Acre", ACT},
	    {"Brazil/DeNoronha", NORONHA},
	    {"Brazil/East", BRT},
	    {"Brazil/West", AMT},
	    {"Canada/Atlantic", AST},
	    {"Canada/Central", CST},
	    {"Canada/East-Saskatchewan", CST},
	    {"Canada/Eastern", EST},
	    {"Canada/Mountain", MST},
	    {"Canada/Newfoundland", NST},
	    {"Canada/Pacific", PST},
	    {"Canada/Yukon", PST},
	    {"Canada/Saskatchewan", CST},
	    {"CAT", CAT},
	    {"CET", CET},
	    {"Chile/Continental", CLT},
	    {"Chile/EasterIsland", EASTER},
	    {"CST6CDT", CST},
	    {"Cuba", CST},
	    {"EAT", EAT},
	    {"EET", EET},
	    {"Egypt", EET},
	    {"Eire", DUBLIN},
	    {"EST5EDT", EST},
	    {"Etc/Greenwich", GMT},
	    {"Etc/UCT", UTC},
	    {"Etc/Universal", UTC},
	    {"Etc/UTC", UTC},
	    {"Etc/Zulu", UTC},
	    {"Europe/Amsterdam", CET},
	    {"Europe/Andorra", CET},
	    {"Europe/Athens", EET},
	    {"Europe/Belfast", GMTBST},
	    {"Europe/Belgrade", CET},
	    {"Europe/Berlin", CET},
	    {"Europe/Bratislava", CET},
	    {"Europe/Brussels", CET},
	    {"Europe/Budapest", CET},
	    {"Europe/Chisinau", EET},
	    {"Europe/Copenhagen", CET},
	    {"Europe/Dublin", DUBLIN},
	    {"Europe/Gibraltar", CET},
	    {"Europe/Helsinki", EET},
	    {"Europe/Istanbul", EET},
	    {"Europe/Kaliningrad", EET},
	    {"Europe/Kiev", EET},
	    {"Europe/Lisbon", WET},
	    {"Europe/Ljubljana", CET},
	    {"Europe/London", GMTBST},
	    {"Europe/Luxembourg", CET},
	    {"Europe/Madrid", CET},
	    {"Europe/Malta", CET},
	    {"Europe/Minsk", EET},
	    {"Europe/Monaco", CET},
	    {"Europe/Moscow", MSK},
	    {"Europe/Nicosia", EET},
	    {"Europe/Oslo", CET},
	    {"Europe/Prague", CET},
	    {"Europe/Riga", EET},
	    {"Europe/Rome", CET},
	    {"Europe/Samara", new String[] {"\u6c99\u99ac\u62c9\u6642\u9593", "SAMT",
					    "\u6c99\u99ac\u62c9\u590f\u4ee4\u6642\u9593", "SAMST"}},
	    {"Europe/San_Marino", CET},
	    {"Europe/Sarajevo", CET},
	    {"Europe/Simferopol", EET},
	    {"Europe/Skopje", CET},
	    {"Europe/Sofia", EET},
	    {"Europe/Stockholm", CET},
	    {"Europe/Tallinn", EET},
	    {"Europe/Tirane", CET},
	    {"Europe/Tiraspol", EET},
	    {"Europe/Uzhgorod", EET},
	    {"Europe/Vaduz", CET},
	    {"Europe/Vatican", CET},
	    {"Europe/Vienna", CET},
	    {"Europe/Vilnius", EET},
	    {"Europe/Warsaw", CET},
	    {"Europe/Zagreb", CET},
	    {"Europe/Zaporozhye", EET},
	    {"Europe/Zurich", CET},
	    {"GB", GMTBST},
	    {"GB-Eire", GMTBST},
	    {"Greenwich", GMT},
	    {"Hongkong", HKT},
	    {"Iceland", GMT},
	    {"Iran", IRT},
	    {"IST", IST},
	    {"Indian/Antananarivo", EAT},
	    {"Indian/Chagos", new String[] {"\u5370\u5ea6\u6d0b Ocean Territory \u6642\u9593", "IOT",
					    "\u5370\u5ea6\u6d0b Ocean Territory \u590f\u4ee4\u6642\u9593", "IOST"}},
	    {"Indian/Christmas", new String[] {"\u8056\u8a95\u5cf6\u6642\u9593", "CXT",
					       "\u8056\u8a95\u5cf6\u590f\u4ee4\u6642\u9593", "CXST"}},
	    {"Indian/Cocos", new String[] {"\u53ef\u53ef\u65af\u7fa4\u5cf6\u6642\u9593", "CCT",
					   "\u53ef\u53ef\u65af\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "CCST"}},
	    {"Indian/Comoro", EAT},
	    {"Indian/Kerguelen", new String[] {"French Southern & Antarctic Lands \u6642\u9593", "TFT",
					       "French Southern & Antarctic Lands \u590f\u4ee4\u6642\u9593", "TFST"}},
	    {"Indian/Mahe", new String[] {"\u585e\u5e2d\u723e\u7fa4\u5cf6\u6642\u9593", "SCT",
					  "\u585e\u5e2d\u723e\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "SCST"}},
	    {"Indian/Maldives", new String[] {"\u99ac\u723e\u5730\u592b\u6642\u9593", "MVT",
					      "\u99ac\u723e\u5730\u592b\u590f\u4ee4\u6642\u9593", "MVST"}},
	    {"Indian/Mauritius", new String[] {"\u6469\u91cc\u897f\u65af\u6642\u9593", "MUT",
					       "\u6469\u91cc\u897f\u65af\u590f\u4ee4\u6642\u9593", "MUST"}},
	    {"Indian/Mayotte", EAT},
	    {"Indian/Reunion", new String[] {"\u7559\u5c3c\u65fa\u5cf6\u6642\u9593", "RET",
					     "\u7559\u5c3c\u65fa\u5cf6\u590f\u4ee4\u6642\u9593", "REST"}},
	    {"Israel", ISRAEL},
	    {"Jamaica", EST},
	    {"Japan", JST},
	    {"Kwajalein", MHT},
	    {"Libya", EET},
	    {"MET", new String[] {"Middle Europe Time", "MET",
				  "Middle Europe Summer Time", "MEST"}},
	    {"Mexico/BajaNorte", PST},
	    {"Mexico/BajaSur", MST},
	    {"Mexico/General", CST},
	    {"MIT", WST_SAMOA},
	    {"MST7MDT", MST},
	    {"Navajo", MST},
	    {"NET", ARMT},
	    {"NST", NZST},
	    {"NZ", NZST},
	    {"NZ-CHAT", CHAST},
	    {"PLT", PKT},
	    {"Portugal", WET},
	    {"PRT", AST},
	    {"Pacific/Apia", WST_SAMOA},
	    {"Pacific/Auckland", NZST},
	    {"Pacific/Chatham", CHAST},
	    {"Pacific/Easter", EASTER},
	    {"Pacific/Efate", new String[] {"\u74e6\u5974\u963f\u5716\u6642\u9593", "VUT",
					    "\u74e6\u5974\u963f\u5716\u590f\u4ee4\u6642\u9593", "VUST"}},
	    {"Pacific/Enderbury", new String[] {"\u83f2\u5c3c\u514b\u65af\u7fa4\u5cf6\u6642\u9593", "PHOT",
						"\u83f2\u5c3c\u514b\u65af\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "PHOST"}},
	    {"Pacific/Fakaofo", new String[] {"\u6258\u514b\u52de\u7fa4\u5cf6\u6642\u9593", "TKT",
					      "\u6258\u514b\u52de\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "TKST"}},
	    {"Pacific/Fiji", new String[] {"\u6590\u6fdf\u6642\u9593", "FJT",
					   "\u6590\u6fdf\u590f\u4ee4\u6642\u9593", "FJST"}},
	    {"Pacific/Funafuti", new String[] {"\u5410\u9b6f\u74e6\u6642\u9593", "TVT",
					       "\u5410\u9b6f\u74e6\u590f\u4ee4\u6642\u9593", "TVST"}},
	    {"Pacific/Galapagos", new String[] {"\u52a0\u62c9\u5df4\u54e5\u6642\u9593", "GALT",
						"\u52a0\u62c9\u5df4\u54e5\u590f\u4ee4\u6642\u9593", "GALST"}},
	    {"Pacific/Gambier", GAMBIER},
	    {"Pacific/Guadalcanal", SBT},
	    {"Pacific/Guam", ChST},
	    {"Pacific/Johnston", HST},
	    {"Pacific/Kiritimati", new String[] {"Line Is. \u6642\u9593", "LINT",
						 "Line Is. \u590f\u4ee4\u6642\u9593", "LINST"}},
	    {"Pacific/Kosrae", new String[] {"Kosrae \u6642\u9593", "KOST",
					     "Kosrae \u590f\u4ee4\u6642\u9593", "KOSST"}},
	    {"Pacific/Kwajalein", MHT},
	    {"Pacific/Majuro", MHT},
	    {"Pacific/Marquesas", new String[] {"\u99ac\u514b\u85a9\u65af\u6642\u9593", "MART",
						"\u99ac\u514b\u85a9\u65af\u590f\u4ee4\u6642\u9593", "MARST"}},
	    {"Pacific/Midway", SAMOA},
	    {"Pacific/Nauru", new String[] {"\u8afe\u9b6f\u6642\u9593", "NRT",
					    "\u8afe\u9b6f\u590f\u4ee4\u6642\u9593", "NRST"}},
	    {"Pacific/Niue", new String[] {"\u7d10\u5a01\u5cf6\u6642\u9593", "NUT",
					   "\u7d10\u5a01\u5cf6\u590f\u4ee4\u6642\u9593", "NUST"}},
	    {"Pacific/Norfolk", new String[] {"\u8afe\u798f\u514b\u6642\u9593", "NFT",
					      "\u8afe\u798f\u514b\u590f\u4ee4\u6642\u9593", "NFST"}},
	    {"Pacific/Noumea", new String[] {"\u65b0\u52a0\u52d2\u591a\u5c3c\u4e9e\u6642\u9593", "NCT",
					     "\u65b0\u52a0\u52d2\u591a\u5c3c\u4e9e\u590f\u4ee4\u6642\u9593", "NCST"}},
	    {"Pacific/Pago_Pago", SAMOA},
	    {"Pacific/Palau", new String[] {"\u5e1b\u7409\u6642\u9593", "PWT",
					    "\u5e1b\u7409\u590f\u4ee4\u6642\u9593", "PWST"}},
	    {"Pacific/Pitcairn", PITCAIRN},
	    {"Pacific/Ponape", new String[] {"Ponape \u6642\u9593", "PONT",
					     "Ponape \u590f\u4ee4\u6642\u9593", "PONST"}},
	    {"Pacific/Port_Moresby", new String[] {"\u5df4\u5e03\u4e9e\u65b0\u5e7e\u5167\u4e9e\u6642\u9593", "PGT",
						   "\u5df4\u5e03\u4e9e\u65b0\u5e7e\u5167\u4e9e\u590f\u4ee4\u6642\u9593", "PGST"}},
	    {"Pacific/Rarotonga", new String[] {"Cook \u7fa4\u5cf6\u6642\u9593", "CKT",
						"Cook \u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "CKST"}},
	    {"Pacific/Saipan", ChST},
	    {"Pacific/Samoa", SAMOA},
	    {"Pacific/Tahiti", new String[] {"\u5927\u6eaa\u5730\u5cf6\u6642\u9593", "TAHT",
					     "\u5927\u6eaa\u5730\u5cf6\u590f\u4ee4\u6642\u9593", "TAHST"}},
	    {"Pacific/Tarawa", new String[] {"\u5409\u4f2f\u7279\u7fa4\u5cf6\u6642\u9593", "GILT",
					     "\u5409\u4f2f\u7279\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "GILST"}},
	    {"Pacific/Tongatapu", new String[] {"\u6771\u52a0\u6642\u9593", "TOT",
						"\u6771\u52a0\u590f\u4ee4\u6642\u9593", "TOST"}},
	    {"Pacific/Truk", new String[] {"\u7279\u9b6f\u514b\u6642\u9593", "TRUT",
					   "\u7279\u9b6f\u514b\u590f\u4ee4\u6642\u9593", "TRUST"}},
	    {"Pacific/Wake", new String[] {"\u5a01\u514b\u6642\u9593", "WAKT",
					   "\u5a01\u514b\u590f\u4ee4\u6642\u9593", "WAKST"}},
	    {"Pacific/Wallis", new String[] {"\u74e6\u5229\u65af\u53ca\u798f\u675c\u7d0d\u7fa4\u5cf6\u6642\u9593", "WFT",
					     "\u74e6\u5229\u65af\u53ca\u798f\u675c\u7d0d\u7fa4\u5cf6\u590f\u4ee4\u6642\u9593", "WFST"}},
	    {"Pacific/Yap", new String[] {"\u96c5\u6d66\u5cf6\u6642\u9593", "YAPT",
					  "\u96c5\u6d66\u5cf6\u590f\u4ee4\u6642\u9593", "YAPST"}},
	    {"Poland", CET},
	    {"PRC", CTT},
	    {"PST8PDT", PST},
	    {"ROK", KST},
	    {"Singapore", SGT},
	    {"SST", SBT},
	    {"SystemV/AST4", AST},
	    {"SystemV/AST4ADT", AST},
	    {"SystemV/CST6", CST},
	    {"SystemV/CST6CDT", CST},
	    {"SystemV/EST5", EST},
	    {"SystemV/EST5EDT", EST},
	    {"SystemV/HST10", HST},
	    {"SystemV/MST7", MST},
	    {"SystemV/MST7MDT", MST},
	    {"SystemV/PST8", PITCAIRN},
	    {"SystemV/PST8PDT", PST},
	    {"SystemV/YST9", GAMBIER},
	    {"SystemV/YST9YDT", AKST},
	    {"Turkey", EET},
	    {"UCT", UTC},
	    {"Universal", UTC},
	    {"US/Alaska", AKST},
	    {"US/Aleutian", HAST},
	    {"US/Arizona", MST},
	    {"US/Central", CST},
	    {"US/Eastern", EST},
	    {"US/Hawaii", HST},
	    {"US/Indiana-Starke", EST},
	    {"US/East-Indiana", EST},
	    {"US/Michigan", EST},
	    {"US/Mountain", MST},
	    {"US/Pacific", PST},
	    {"US/Pacific-New", PST},
	    {"US/Samoa", SAMOA},
	    {"UTC", UTC},
	    {"VST", ICT},
	    {"W-SU", MSK},
	    {"WET", WET},
	    {"Zulu", UTC},

            {"localPatternChars", "GyMdkHmsSEDFwWahKzZ"},
        };
    }
}
