/*
 * @(#)csmatrix.h	1.10 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 	@(#)csmatrix.h	1.21 98/07/07

	Contains:	private definitions required by the color space to
			transform software

	Created by PGT, Nov 1, 1993
	From RFP prototype on Sun

	COPYRIGHT (c) 1993-1998 Eastman Kodak Company
	As an unpublished work pursuant to Title 17 of the United
	States Code.  All rights reserved.
 */


#if !defined(CSMATRIX_H)
#define CSMATRIX_H

#include <math.h>
#include "matdata.h"


/* Convenient Notations */

#ifndef NULL
#define NULL	(0)
#endif

#define ALLOC(number,size)	(allocBufferPtr((KpInt32_t)((number)*(size))))

#define	DALLOC(ptr)	(freeBufferPtr((KpChar_p)(ptr)),\
				(ptr) = NULL)	/* deallocate memory */

#define	SLOPE_COUNT 128		/* limit the slope if less than SLOPE_COUNT */
#define	SLOPE_LIMIT 16		/* limit the slope to SLOPE_LIMIT */

/* Private Function Prototypes */

double f4l (double x, double xtab[], double ytab[], KpInt32_t n, KpInt32_p hint);
void calcGtbl3 (fut_gtbldat_p*, KpInt32_p, double**,KpBool_t);
void calcItbl1 (fut_itbldat_p, KpInt32_t, double);
void calcItbl256 (fut_itbldat_p, KpInt32_t, KpUInt16_p);
PTErr_t calcItblN (fut_itbldat_p table, KpInt32_t gridSize, ResponseRecord* rrp, KpUInt32_t interpMode);
void calcOtbl0 (fut_otbldat_p);
void calcOtbl1 (fut_otbldat_p, double);
PTErr_t calcOtblN (fut_otbldat_p table, ResponseRecord* rrp, KpUInt32_t interpMode);
double calcInvertTRC (double p, KpUInt16_p data, KpUInt32_t length);
KpInt32_t solvemat (KpInt32_t, double**, double*);

#endif
