/*
 *  @(#)GlyphLayout.h	1.7 03/01/23
 *
 * (C) Copyright IBM Corp. 1999-2001 - All Rights Reserved
 *
 * Portions Copyright 2003 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by IBM. These materials are provided
 * under terms of a License Agreement between IBM and Sun.
 * This technology is protected by multiple US and International
 * patents. This notice and attribution to IBM may not be removed.
 */

#ifndef __GLYPHLAYOUT_H
#define __GLYPHLAYOUT_H

#include "FontGlue.h"
#include "LayoutEngine.h"
#include "TX.h"

struct ScriptInfo
{
	le_int32 scriptStart;
	le_int32 scriptCode;
	le_int32 scriptSlot;
	LayoutEngine *engine;
};

class GlyphLayout
{
private:

	enum {
		eDefaultStorage = 5,
		eGrowStorage = 5
	};

	le_int32 fNumGlyphs;
	le_int32 fScriptCount;
	le_int32 fScriptMax;
	le_bool fRightToLeft; 
	TX fDevTX;

	ScriptInfo fScriptInfoBase[eDefaultStorage + 1];
	ScriptInfo *fScriptInfo;

	void growScriptInfo();

public:

    GlyphLayout(JNIEnv *env, jcharArray unicodes, jint offset, jint count,
            jint flags, jdoubleArray fontTX, jdoubleArray devTX, 
	    jboolean isAntiAliased, jboolean usesFractionalMetrics, fontObject *fo);
    ~GlyphLayout();

    void updateGlyphVector(JNIEnv *env, jobject glyphVector, int extraBits);

private:
    GlyphLayout();              // no implementation
    GlyphLayout(GlyphLayout&);  // no implementation
    GlyphLayout& operator =(const GlyphLayout&);
    static void *operator new(size_t size);
    static void operator delete(void *ptr);

};

#endif


