/*
 *  @(#)uchardir.c	1.2 03/01/23
 *
 * (C) Copyright IBM Corp. 1999-2000 - All Rights Reserved
 *
 * Portions Copyright 2003 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 *
 * The original version of this source code and documentation is
 * copyrighted and owned by IBM. These materials are provided
 * under terms of a License Agreement between IBM and Sun.
 * This technology is protected by multiple US and International
 * patents. This notice and attribution to IBM may not be removed.
 */

/*
*
* File UCHAR.CPP
*
* Modification History:
*
*   Date        Name        Description
*   11/30/1999  dfelt       Creation.  Extract from uchar.c, reduce to data 
*                             query only.
********************************************************************************
*/

#include "uchardir.h"

/* This data was (presumably) built from the unicode data defined in 
   uchardir.h */

static const uint16_t fCharDirIndices[] = {
    (uint16_t)0, (uint16_t)127, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)318, (uint16_t)446, 
    (uint16_t)573, (uint16_t)247, (uint16_t)698, 
    (uint16_t)247, (uint16_t)816, (uint16_t)933, 
    (uint16_t)1046, (uint16_t)1174, (uint16_t)1302, 
    (uint16_t)247, (uint16_t)247, (uint16_t)1429, 
    (uint16_t)1556, (uint16_t)1682, (uint16_t)1793, 
    (uint16_t)1869, (uint16_t)1953, (uint16_t)2031, 
    (uint16_t)2118, (uint16_t)2196, (uint16_t)2274, 
    (uint16_t)2361, (uint16_t)2440, (uint16_t)2544, 
    (uint16_t)2666, (uint16_t)2749, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)2877, 
    (uint16_t)247, (uint16_t)2950, (uint16_t)3078, 
    (uint16_t)3165, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)3232, 
    (uint16_t)3360, (uint16_t)3488, (uint16_t)3616, 
    (uint16_t)3728, (uint16_t)3856, (uint16_t)3876, 
    (uint16_t)3936, (uint16_t)4061, (uint16_t)4189, 
    (uint16_t)4289, (uint16_t)4417, (uint16_t)4523, 
    (uint16_t)4651, (uint16_t)247, (uint16_t)4778, 
    (uint16_t)4896, (uint16_t)4417, (uint16_t)4417, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)5024, 
    (uint16_t)4417, (uint16_t)5054, (uint16_t)5182, 
    (uint16_t)5285, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)5409, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)247, (uint16_t)247, (uint16_t)247, 
    (uint16_t)5508, (uint16_t)5588, (uint16_t)5671, 
    (uint16_t)5671, (uint16_t)5737, (uint16_t)5849, 
    (uint16_t)5973, (uint16_t)6091, (uint16_t)6219, 
    (uint16_t)6321 
};

/* values must correspond to those defined in uchardir.h. */
static const int8_t fCharDirValues[] = {
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)8, (int8_t)7, 
    (int8_t)8, (int8_t)9, (int8_t)7, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)7, (int8_t)7, (int8_t)7, 
    (int8_t)8, (int8_t)9, (int8_t)10, (int8_t)10, (int8_t)4, 
    (int8_t)4, (int8_t)4, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)4, (int8_t)6, (int8_t)4, 
    (int8_t)6, (int8_t)3, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)6, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)7, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)6, (int8_t)10, 
    (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)4, 
    (int8_t)4, (int8_t)2, (int8_t)2, (int8_t)10, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)2, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)1, (int8_t)17, (int8_t)1, 
    (int8_t)17, (int8_t)17, (int8_t)1, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)6, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)13, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)13, (int8_t)0, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)5, (int8_t)5, 
    (int8_t)5, (int8_t)5, (int8_t)5, (int8_t)5, (int8_t)5, 
    (int8_t)5, (int8_t)5, (int8_t)5, (int8_t)4, (int8_t)5, 
    (int8_t)5, (int8_t)13, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)13, (int8_t)13, (int8_t)17, (int8_t)17, 
    (int8_t)10, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)0, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)0, (int8_t)18, (int8_t)13, 
    (int8_t)17, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)4, 
    (int8_t)4, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)4, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)0, (int8_t)17, (int8_t)0, 
    (int8_t)17, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)17, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)0, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)9, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)4, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)18, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)9, 
    (int8_t)9, (int8_t)9, (int8_t)9, (int8_t)9, (int8_t)9, 
    (int8_t)9, (int8_t)9, (int8_t)9, (int8_t)9, (int8_t)9, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)0, (int8_t)1, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)9, 
    (int8_t)7, (int8_t)11, (int8_t)14, (int8_t)16, (int8_t)12, 
    (int8_t)15, (int8_t)9, (int8_t)4, (int8_t)4, (int8_t)4, 
    (int8_t)4, (int8_t)4, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)18, 
    (int8_t)18, (int8_t)2, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)4, (int8_t)4, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)4, (int8_t)4, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)4, 
    (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)4, 
    (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)4, 
    (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)4, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)0, (int8_t)10, 
    (int8_t)0, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)4, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)4, (int8_t)4, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)2, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, 
    (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)9, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)17, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)10, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)1, (int8_t)17, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)4, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)0, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)0, (int8_t)1, 
    (int8_t)0, (int8_t)1, (int8_t)1, (int8_t)0, (int8_t)1, 
    (int8_t)1, (int8_t)0, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, (int8_t)1, 
    (int8_t)1, (int8_t)1, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)0, 
    (int8_t)0, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)17, 
    (int8_t)17, (int8_t)17, (int8_t)17, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)6, (int8_t)10, (int8_t)6, 
    (int8_t)0, (int8_t)10, (int8_t)6, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)4, (int8_t)10, (int8_t)10, 
    (int8_t)4, (int8_t)4, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)10, (int8_t)4, (int8_t)4, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)0, (int8_t)13, (int8_t)0, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, (int8_t)13, 
    (int8_t)0, (int8_t)0, (int8_t)18, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)4, (int8_t)4, (int8_t)4, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)4, 
    (int8_t)6, (int8_t)4, (int8_t)6, (int8_t)3, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, 
    (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)2, (int8_t)6, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)0, (int8_t)0, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)4, (int8_t)4, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)4, (int8_t)4, (int8_t)0, (int8_t)10, 
    (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, (int8_t)0, 
    (int8_t)0, (int8_t)18, (int8_t)18, (int8_t)18, (int8_t)10, 
    (int8_t)10, (int8_t)0, (int8_t)0 
};

/* Gets the character's linguistic directionality.*/
UCharDirection
u_charDirection(UChar ch) {
	return (UCharDirection)fCharDirValues[fCharDirIndices[ch >> 7] + (ch & 0x7f)];
}

#if 0
// original source code simplified to the above implmentation

static const int32_t fCharDirCount = 6449;

static  bool_t  dirTablesCreated=FALSE;

static  void    createDirTables(void);

UCharDirection
u_charDirection(UChar ch)
{   
    /* Lazy evaluate the character directionality table; only instantiate when necessary. */
    if (!dirTablesCreated) {
        createDirTables();
    }
    return (UCharDirection)(ucmp8_get(dirTables, ch));
}

// createDirTables
      newTables = ucmp8_openAdopt((uint16_t*)fCharDirIndices,
                  (int8_t*)fCharDirValues,
                  fCharDirCount);

#define kUnicodeCount_int 65536
#define kBlockShift_int 7
#define kBlockCount_int (1<<kBlockShift_int)
#define kIndexShift_int (16-kBlockShift_int)
#define kIndexCount_int (1<<kIndexShift_int)
#define kBlockMask_int (kBlockCount_int-1)

const int32_t UCMP8_kUnicodeCount = kUnicodeCount_int;
const int32_t UCMP8_kBlockShift = kBlockShift_int;
const int32_t UCMP8_kBlockCount = kBlockCount_int;
const int32_t UCMP8_kIndexShift = kIndexShift_int;
const int32_t UCMP8_kIndexCount = kIndexCount_int;
const uint32_t UCMP8_kBlockMask = kBlockMask_int;

CompactByteArray* ucmp8_openAdopt(uint16_t *indexArray,
                  int8_t *newValues,
                  int32_t count)
{
  CompactByteArray* this_obj = (CompactByteArray*) icu_malloc(sizeof(CompactByteArray));
  if (!this_obj) return NULL;
  
  this_obj->fArray = NULL;
  this_obj->fIndex = NULL; 
  this_obj->fCount = count;
  this_obj->fBogus = FALSE;
  
  this_obj->fArray = newValues;
  this_obj->fIndex = indexArray;
  this_obj->fCompact = (count < UCMP8_kUnicodeCount) ? TRUE : FALSE;

  return this_obj;
}

U_CAPI int8_t ucmp8_get(CompactByteArray* array, uint16_t index) 
{
    return (array->fArray[(array->fIndex[index >> UCMP8_kBlockShift] & 0xFFFF) + (index & UCMP8_kBlockMask)]);
}

#endif

