/*
 * @(#)GlyphMemCache.h	1.3 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#include "MemCache.h"
#include "hsGText.h"

class GlyphMemCache : private MemCache {
public:
  GlyphMemCache(UInt16 maxEntries, UInt16 nearLimit, UInt32 maxMem, Boolean purgeOn) 
    : MemCache(maxEntries, nearLimit, maxMem, purgeOn) {
  }

  virtual UInt16 assignGlyphImage(UInt32 ownerID, hsGGlyph& glyph, Boolean *purged = 0);

  virtual const void* getGlyphImage(UInt32 ownerID, UInt16& index, Boolean *purged = 0);

  virtual const void* refGlyphImage(UInt32 ownerID, UInt16 index);

  virtual void reserveGlyphs(UInt16 numGlyphs, UInt32 memSize, Boolean *purged);

  virtual void releaseAllGlyphs();
  
protected:
  virtual void disposeMemPtr(void* mem);
};
