
/*
 * @(#)LETypes.h	1.5 01/02/02
 *
 * (C) Copyright IBM Corp. 1998, 1999, 2000 - All Rights Reserved
 *
 */

/* Used for definition of _LP64 */
#include <sys/types.h>

#ifndef __LETYPES_H
#define __LETYPES_H
#ifndef _LP64
typedef long le_int32;
typedef unsigned long le_uint32;
#else
typedef int le_int32;
typedef unsigned int le_uint32;
#endif

typedef short le_int16;
typedef unsigned short le_uint16;
typedef signed char le_int8;
typedef unsigned char le_uint8;

typedef char le_bool;

#ifndef true
#define true 1
#endif

#ifndef false
#define false 0
#endif

#ifndef NULL
#define NULL 0
#endif

typedef le_uint32 LETag;

typedef le_uint16 LEGlyphID;

typedef le_uint16 LEUnicode16;
typedef le_uint32 LEUnicode32;
typedef le_uint16 LEUnicode;	// FIXME: we should depricate this type in favor of LEUnicode16...

struct LEPoint
{
    float fX;
    float fY;
};

#define LE_ARRAY_COPY(dst, src, count) memcpy(dst, src, (count) * sizeof (src)[0])

enum LEErrorCode {
	/* informational */
	// none right now...

	/* success */
	LE_NO_ERROR						= 0,

	/* failures */
	LE_ILLEGAL_ARGUMENT_ERROR		= 1,
	LE_MEMORY_ALLOCATION_ERROR		= 2,
	LE_INDEX_OUT_OF_BOUNDS_ERROR	= 3,
	LE_NO_LAYOUT_ERROR				= 4,
	LE_INTERNAL_ERROR				= 5
};

#define LE_SUCCESS(code) ((code)<=LE_NO_ERROR)
#define LE_FAILURE(code) ((code)>LE_NO_ERROR)

#define U_LAYOUT_API
#endif


