/*
 * @(#)mlib_ImageColormap.h	1.9 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef MLIB_IMAGECOLORMAP_H
#define MLIB_IMAGECOLORMAP_H

#ifdef __SUNPRO_C
#pragma ident	"@(#)mlib_ImageColormap.h	1.14	98/06/26 SMI"
#endif /* __SUNPRO_C */

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  void **lut;
  mlib_s32 channels;
  mlib_type intype;
  mlib_s32 offset;                                                           
  void *table;
  mlib_s32 bits;
  mlib_s32 method;
  mlib_s32 lutlength;
  mlib_s32 indexsize;
  mlib_type outtype;
  void *normal_table;
  mlib_d64 *double_lut;
} mlib_colormap;

#define mlib_ImageGetLutData( colormap ) \
  ( ( void ** )( ( ( mlib_colormap * )( colormap ) )->lut ) )

#define mlib_ImageGetLutNormalTable( colormap ) \
  ( ( void * )( ( ( mlib_colormap * )( colormap ) )->normal_table ) )
  
#define mlib_ImageGetLutInversTable( colormap ) \
  ( ( void * )( ( ( mlib_colormap * )( colormap ) )->table ) )

#define mlib_ImageGetLutChannels( colormap ) \
  ( ( mlib_s32 )( ( ( mlib_colormap * )( colormap ) )->channels ) )

#define mlib_ImageGetLutType( colormap ) \
  ( ( mlib_type )( ( ( mlib_colormap * )( colormap ) )->intype ) )

#define mlib_ImageGetIndexSize( colormap ) \
  ( ( mlib_s32 )( ( ( mlib_colormap * )( colormap ) )->indexsize ) )

#define mlib_ImageGetOutType( colormap ) \
  ( ( mlib_type )( ( ( mlib_colormap * )( colormap ) )->outtype ) )

#define mlib_ImageGetLutOffset( colormap ) \
  ( ( mlib_s32 )( ( ( mlib_colormap * )( colormap ) )->offset ) )
  
#define mlib_ImageGetBits( colormap ) \
  ( ( mlib_s32 )( ( ( mlib_colormap * )( colormap ) )->bits ) )
  
#define mlib_ImageGetMethod( colormap ) \
  ( ( mlib_s32 )( ( ( mlib_colormap * )( colormap ) )->method ) )
  
#define mlib_ImageGetLutDoubleData( colormap ) \
  ( ( mlib_d64 * )( ( ( mlib_colormap * )( colormap ) )->double_lut ) )


void mlib_ImageColorTrue2IndexLine_U8_U8_3( mlib_u8 *src,
                                            mlib_u8 *dst,
                                            mlib_s32 length,
                                            void *colormap );

void mlib_ImageColorTrue2IndexLine_U8_U8_3_in_4( mlib_u8 *src,
                                            mlib_u8 *dst,
                                            mlib_s32 length,
                                            void *colormap );

void mlib_ImageColorTrue2IndexLine_U8_U8_4( mlib_u8 *src,
                                            mlib_u8 *dst,
                                            mlib_s32 length,
                                            void *colormap );

void mlib_ImageColorTrue2IndexLine_U8_S16_3( mlib_u8 *src,
                                             mlib_s16 *dst,
                                             mlib_s32 length,
                                             void *colormap );

void mlib_ImageColorTrue2IndexLine_U8_S16_3_in_4( mlib_u8 *src,
                                             mlib_s16 *dst,
                                             mlib_s32 length,
                                             void *colormap );

void mlib_ImageColorTrue2IndexLine_U8_S16_4( mlib_u8 *src,
                                             mlib_s16 *dst,
                                             mlib_s32 length,
                                             void *colormap );

void mlib_ImageColorTrue2IndexLine_S16_S16_3( mlib_s16 *src,
                                              mlib_s16 *dst,
                                              mlib_s32 length,
                                              void *colormap );

void mlib_ImageColorTrue2IndexLine_S16_S16_3_in_4( mlib_s16 *src,
                                              mlib_s16 *dst,
                                              mlib_s32 length,
                                              void *colormap );

void mlib_ImageColorTrue2IndexLine_S16_S16_4( mlib_s16 *src,
                                              mlib_s16 *dst,
                                              mlib_s32 length,
                                              void *colormap );

void mlib_ImageColorTrue2IndexLine_S16_U8_3( mlib_s16 *src,
                                             mlib_u8 *dst,
                                             mlib_s32 length,
                                             void *colormap );

void mlib_ImageColorTrue2IndexLine_S16_U8_3_in_4( mlib_s16 *src,
                                             mlib_u8 *dst,
                                             mlib_s32 length,
                                             void *colormap );

void mlib_ImageColorTrue2IndexLine_S16_U8_4( mlib_s16 *src,
                                             mlib_u8 *dst,
                                             mlib_s32 length,
                                             void *colormap );

#ifdef __cplusplus
}
#endif

#endif	/* MLIB_IMAGECOLORMAP_H */
