/*
 * @(#)mlib_SysMath.h	1.12 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef MLIB_SYSMATH_H
#define MLIB_SYSMATH_H

#ifdef __SUNPRO_C
#pragma ident	"@(#)mlib_SysMath.h	1.11	98/09/25 SMI"
#endif /* __SUNPRO_C */

#include <math.h>

#define mlib_sin        sin
#define mlib_cos        cos
#define mlib_sqrt       sqrt
#define mlib_fabs       fabs
#define mlib_ceil       ceil

#ifdef MLIB_LIBCAFEMATH

#define mlib_sinf       sinf
#define mlib_cosf       cosf
static void mlib_sincosf (float x, float *s, float *c)
{
  *s = sinf(x);
  *c = cosf(x);
}
#define mlib_sqrtf       sqrtf
#define mlib_fabsf       fabsf

#else

#ifdef MLIB_NO_LIBSUNMATH

#define mlib_sinf       (float) sin
#define mlib_cosf       (float) cos
static void mlib_sincosf (float x, float *s, float *c)
{
  *s = (float)sin(x);
  *c = (float)cos(x);
}
#define mlib_sqrtf      (float) sqrt
#define mlib_fabsf      (float) fabs

#else

#include <sunmath.h>

#define mlib_sinf       sinf
#define mlib_cosf       cosf
#define mlib_sincosf    sincosf
#define mlib_sqrtf       sqrtf
#define mlib_fabsf       fabsf

#endif  /* MLIB_NO_LIBSUNMATH */

#endif  /* MLIB_LIBCAFEMATH */


  /* internal mathematical functions */

double mlib_sincospi(double x, double *co);
double mlib_atan2i (int y, int x);
int    mlib_ilogb (double x);

#endif /* MLIB_SYSMATH_H */
