/*
 * @(#)Index12Gray.h	1.4 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef Index12Gray_h_Included
#define Index12Gray_h_Included

#include "IntDcm.h"
#include "ByteGray.h"

/*
 * This file contains macro and type definitions used by the macros in
 * LoopMacros.h to manipulate a surface of type "Index12Gray".
 */

typedef jushort	Index12GrayPixelType;
typedef jushort	Index12GrayDataType;

#define Index12GrayPixelStride		2

#define DeclareIndex12GrayLoadVars(PREFIX) \
    jint *PREFIX ## Lut;

#define DeclareIndex12GrayStoreVars(PREFIX) \
    jint *PREFIX ## InvGrayLut;

#define SetIndex12GrayStoreVarsYPos(PREFIX, pRasInfo, LOC)
#define SetIndex12GrayStoreVarsXPos(PREFIX, pRasInfo, LOC)
#define InitIndex12GrayLoadVars(PREFIX, pRasInfo) \
    PREFIX ## Lut = (pRasInfo)->lutBase

#define InitIndex12GrayStoreVarsY(PREFIX, pRasInfo) \
    PREFIX ## InvGrayLut = (pRasInfo)->invGrayTable;

#define InitIndex12GrayStoreVarsX(PREFIX, pRasInfo)
#define NextIndex12GrayStoreVarsX(PREFIX)
#define NextIndex12GrayStoreVarsY(PREFIX)

#define Index12GrayXparLutEntry			-1
#define Index12GrayIsXparLutEntry(pix)		(pix < 0)
#define StoreIndex12GrayNonXparFromArgb	        StoreIndex12GrayFrom1IntArgb

#define StoreIndex12GrayPixel(pRas, x, pixel) \
    ((pRas)[x] = (jushort) (pixel))

#define DeclareIndex12GrayPixelData(PREFIX)

#define ExtractIndex12GrayPixelData(PIXEL, PREFIX)

#define StoreIndex12GrayPixelData(pPix, x, pixel, PREFIX) \
    ((pPix)[x] = (jushort) (pixel))

#define Index12GrayPixelFromArgb(pixel, rgb, pRasInfo) \
    do { \
        jint r, g, b, gray; \
        ExtractIntDcmComponentsX123(rgb, r, g, b); \
        gray = ComposeByteGrayFrom3ByteRgb(r, g, b); \
        (pixel) = (pRasInfo)->invGrayTable[gray]; \
    } while (0)

#define LoadIndex12GrayTo1IntRgb(pRas, PREFIX, x, rgb) \
    (rgb) = PREFIX ## Lut[pRas[x] & 0xfff]

#define LoadIndex12GrayTo1IntArgb(pRas, PREFIX, x, argb) \
    (argb) = PREFIX ## Lut[pRas[x] & 0xfff]

#define LoadIndex12GrayTo1ByteGray(pRas, PREFIX, x, gray) \
    (gray) = (jubyte)PREFIX ## Lut[pRas[x] & 0xfff]

#define LoadIndex12GrayTo3ByteRgb(pRas, PREFIX, x, r, g, b) \
    r = g = b = (jubyte)PREFIX ## Lut[pRas[x] & 0xfff]

#define LoadIndex12GrayTo4ByteArgb(pRas, PREFIX, x, a, r, g, b) \
    do { \
        a = 0xff; \
        LoadIndex12GrayTo3ByteRgb(pRas, PREFIX, x, r, g, b); \
    } while (0)

#define StoreIndex12GrayFrom1IntRgb(pRas, PREFIX, x, rgb) \
    do { \
	int r, g, b; \
	ExtractIntDcmComponentsX123(rgb, r, g, b); \
	StoreIndex12GrayFrom3ByteRgb(pRas, PREFIX, x, r, g, b); \
    } while (0)

#define StoreIndex12GrayFrom1IntArgb(pRas, PREFIX, x, argb) \
    StoreIndex12GrayFrom1IntRgb(pRas, PREFIX, x, argb)

#define StoreIndex12GrayFrom3ByteRgb(pRas, PREFIX, x, r, g, b) \
    do { \
        int gray = ComposeByteGrayFrom3ByteRgb(r, g, b); \
        (pRas)[x] = (jushort) (PREFIX ## InvGrayLut[gray]); \
    } while (0)

#define StoreIndex12GrayFrom4ByteArgb(pRas, PREFIX, x, a, r, g, b) \
    StoreIndex12GrayFrom3ByteRgb(pRas, PREFIX, x, r, g, b)

#define StoreIndex12GrayFrom1ByteGray(pRas, PREFIX, x, gray) \
    (pRas)[x] = (jushort) (PREFIX ## InvGrayLut[gray]);

#define DeclareIndex12GrayAlphaLoadData(PREFIX) \
    jint *PREFIX ## Lut;

#define InitIndex12GrayAlphaLoadData(PREFIX, pRasInfo) \
    PREFIX ## Lut = (pRasInfo)->lutBase

#define LoadAlphaFromIndex12GrayFor1ByteGray(pRas, PREFIX, COMP_PREFIX) \
    COMP_PREFIX ## A = 0xff

#define Postload1ByteGrayFromIndex12Gray(pRas, PREFIX, COMP_PREFIX) \
    COMP_PREFIX ## G = (jubyte)PREFIX ## Lut[(pRas)[0] & 0xfff]

#define StoreIndex12GrayFrom1ByteGrayComps(pRas, PREFIX, x, COMP_PREFIX) \
    StoreIndex12GrayFrom1ByteGray(pRas, PREFIX, x, COMP_PREFIX ## G)

#define Index12GrayIsPremultiplied	0

#define DeclareIndex12GrayBlendFillVars(PREFIX)

#define InitIndex12GrayBlendFillVarsNonPre(PREFIX, argb, COMP_PREFIX)

#define InitIndex12GrayBlendFillVarsPre(PREFIX, argb, COMP_PREFIX)

#endif /* Index12Gray_h_Included */
