/*
 * @(#)sysSocket.h	1.11 03/01/23
 *
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#ifndef _JAVASOFT_WIN32_SOCKET_MD_H

#include <jni.h>
#include <sys/types.h>
#include "sys.h"
#include "socket_md.h"

#ifdef _LP64
typedef unsigned int    UINT32;
typedef int             INT32;
#else /* _LP64 */
typedef unsigned long   UINT32;
typedef long            INT32;
#endif /* _LP64 */

int dbgsysSocketClose(int fd);
INT32 dbgsysSocketAvailable(int fd, INT32 *pbytes);
int dbgsysConnect(int fd, struct sockaddr *him, int len);
int dbgsysAccept(int fd, struct sockaddr *him, int *len);
int dbgsysSendTo(int fd, char *buf, int len, int flags, struct sockaddr *to,
	      int tolen);
int dbgsysRecvFrom(int fd, char *buf, int nbytes, int flags,
                struct sockaddr *from, int *fromlen);
int dbgsysListen(int fd, INT32 count);
int dbgsysRecv(int fd, char *buf, int nBytes, int flags);
int dbgsysSend(int fd, char *buf, int nBytes, int flags);
int dbgsysTimeout(int fd, INT32 timeout); 
struct hostent *dbgsysGetHostByName(char *hostname);
int dbgsysSocket(int domain, int type, int protocol);
int dbgsysBind(int fd, struct sockaddr *name, int namelen);
int dbgsysSetSocketOption(int fd, jint cmd, jboolean on, jvalue value);
UINT32 dbgsysHostToNetworkLong(UINT32 hostlong);
unsigned short dbgsysHostToNetworkShort(unsigned short hostshort);
UINT32 dbgsysNetworkToHostLong(UINT32 netlong);
unsigned short dbgsysNetworkToHostShort(unsigned short netshort);
int dbgsysGetSocketName(int fd, struct sockaddr *him, int *len);

#endif


